--[[ 
Kharthus's Hunter Timers by Kharthus of Deathwing

v2.1.4
	- Updated German translations
	- Fixed stacked procs from Ashtongue Talisman of Swiftness
v2.1.3
	- Updated toc for 2.2 patch
v2.1.2
	- Added Beast Lord set bonus
v2.1.1
	- Added Skyguard Silver Cross
	- Fixed stacked Haste procs from Dragonspine Trophy
v2.1
	- French/German updates
	- Timers should grow up/down correctly
	- Added Talon of Al'ar
	- Added Darkmoon Card: Wrath
	- Added Darkmoon Card: Madness
	- Added pet frenzy
v2.0
	- Spanish updates
	- Added Desolation set proc
	- Added Thundering Skyfire Diamond
	- Added Tsunami Talisman
	- Added Dragonspine Trophy
	- Added Ashtongue Talisman of Swiftness
	- Corrected Snake Trap trigger

]]

local checkForSpell = 0;
local trapTimer = nil;
local trapRank = 1;
--local dimin = {};
local khtAutoShot = false;
local khtImpConc = false;
local khtRapidFire = false;
local khtQuickShots = false;
local khtPetIntim = false;
local khtIntimidation = false;
local khtWingClip = false;
local khtImpWing = false;
local khtFreezing = false;
local khtScatter = false;
local khtWyvern = false;
local khtFearBeast = false;
local khtExposeWeakness = false;
local khtHuntersMark = false;
local khtPrimalBlessing = false;
local khtEntrapment = false;
local khtBerserking = false;
local khtJomGabbar = false;
local khtSpider = false;
local khtFerocious = false;
local khtTactician = false;
local khtConcBarrage = false;
local khtWrath = false;
local khtPetFrenzy = false;
local khtHaste = false;
local khtSkyguard = false;
local khtBeastLord = false;
local khtAshtongue = false;

local khtTimeLeft = nil;
local khtDebug = false;
local khtDebugBC = false;

function KHunterTimers_OnLoad()
	local playerClass, englishClass = UnitClass("player");
	if(englishClass ~= "HUNTER") then
		return;
	end
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("SPELLS_CHANGED");
	this:RegisterEvent("CHARACTER_POINTS_CHANGED");
	this:RegisterEvent("PLAYER_ALIVE");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER");
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF");
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
	this:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE");
	this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
	this:RegisterEvent("START_AUTOREPEAT_SPELL");
	this:RegisterEvent("STOP_AUTOREPEAT_SPELL");
	this:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");

	this:RegisterEvent("ADDON_ACTION_FORBIDDEN");
	this:RegisterEvent("ADDON_ACTION_BLOCKED");
	this:RegisterEvent("UNIT_SPELLCAST_SENT");
	this:RegisterEvent("UNIT_SPELLCAST_FAILED");
--	this:RegisterEvent("UNIT_SPELLCAST_START");
--	this:RegisterEvent("UNIT_SPELLCAST_STOP");
--	this:RegisterAllEvents(); 
	
	tinsert(UISpecialFrames,"KHunterTimersOptions");
	
	if(DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("Kharthus's Hunter Timers "..KHT_VERSION.." Loaded", 1, 0, 0 );
	end
	
	SlashCmdList["KHUNTERTIMERS"] = function (msg)
		KHunterTimers_SlashCmd(msg);
	end
	SLASH_KHUNTERTIMERS1 = "/khuntertimers";
	SLASH_KHUNTERTIMERS2 = "/kht";
	
end

function KHunterTimers_SlashCmd(msg)
	if( msg == "showvars" ) then
		if( khtExposeWeakness ) then
			DEFAULT_CHAT_FRAME:AddMessage("exposeweak", 1, 0, 0 );
		else
			DEFAULT_CHAT_FRAME:AddMessage("exposeweak "..KHT_OFF, 1, 0, 0 );
		end
		return;
	elseif( msg == "menu" ) then
		KHunterTimers_ShowOptions();
		return;
	elseif( msg == "reset" ) then
		for num = 1, 11, 1 do
			frame = getglobal("KHunterTimersStatus"..num);
			frame.endTime = 0;
		end
		KHunterTimers_ClearActiveSpells();
		return;
	elseif( msg == "clear all" ) then
		KHunterTimers_ResetOptions();
		DEFAULT_CHAT_FRAME:AddMessage("KHT options reset to defaults.", 1, 0, 0);
		for num = 1, 11, 1 do
			frame = getglobal("KHunterTimersStatus"..num);
			frame.endTime = 0;
		end
		KHunterTimers_ClearActiveSpells();
		return;
	elseif( msg == "debug" ) then
		if ( khtDebug ) then
			khtDebug = false;
			DEFAULT_CHAT_FRAME:AddMessage("KHT debugging mode disabled.", 1, 0, 0);
		else
			khtDebug = true;
			DEFAULT_CHAT_FRAME:AddMessage("KHT debugging mode enabled.", 1, 0, 0);
		end
		return;
	elseif( msg == "debugbc" ) then
		if ( khtDebugBC ) then
			khtDebugBC = false;
			DEFAULT_CHAT_FRAME:AddMessage("KHT Burning Crusade debugging mode disabled.", 1, 0, 0);
		else
			khtDebugBC = true;
			DEFAULT_CHAT_FRAME:AddMessage("KHT Burning Crusade debugging mode enabled.", 1, 0, 0);
		end
		return;
	elseif( msg == KHT_ON ) then
		if( KHTvars[KHT_ON] ) then
			DEFAULT_CHAT_FRAME:AddMessage("KHT already "..KHT_ON, 1, 0, 0);
			return;
		else
			KHTvars[KHT_ON] = true;
			DEFAULT_CHAT_FRAME:AddMessage("KHT "..KHT_ON, 1, 0, 0);
			return;
		end
	elseif( msg == KHT_OFF ) then
		if( KHTvars[KHT_ON] ) then
			KHTvars[KHT_ON] = false;
			DEFAULT_CHAT_FRAME:AddMessage("KHT "..KHT_OFF, 1, 0, 0);
			return;
		else
			DEFAULT_CHAT_FRAME:AddMessage("KHT not "..KHT_ON, 1, 0, 0);
			return;
		end
	elseif( string.find( msg, "setbgcolor" ) ) then
		for r, g, b, a in string.gmatch( msg, "setcolor (%d+) (%d+) (%d+) (%d+)" ) do
			KHTvars["bg"].r = r/10;
			KHTvars["bg"].g = g/10;
			KHTvars["bg"].b = b/10;
			KHTvars["bg"].a = a/10;
			KHunterTimersFrame:SetBackdropColor( r/10, g/10, b/10, a/10 );
		end
		return;
	elseif( string.find(msg, "delay" ) ) then
		for ms in string.gmatch(msg, "delay (%d+)") do
			KHTvars["shotdelay"] = ms;
			DEFAULT_CHAT_FRAME:AddMessage("Shot delay set to "..ms.."ms");
		end
	elseif( string.find(msg, "scale" ) ) then
		for scale in string.gmatch( msg, "scale (%d+)" ) do
			if( (scale/100) < 0.1 ) then
				scale = 10;
			end
			scale = scale * UIParent:GetScale();
			KHTvars["scale"] = scale/100;
		end
		KHunterTimersFrame:SetScale( KHTvars["scale"] );
		for i=1, 11 do
			getglobal("KHunterTimersStatus"..i):SetScale( KHTvars["scale"] );
		end
	elseif( string.find(msg, "down") ) then
		KHTvars["down"] = true;
		KHunterTimers_SetSettings();
		DEFAULT_CHAT_FRAME:AddMessage("KHT: Growing down");
	elseif( string.find(msg, "up" ) ) then
		KHTvars["down"] = false;
		KHunterTimers_SetSettings();
		DEFAULT_CHAT_FRAME:AddMessage("KHT: Growing up");
	elseif( msg == "unlock" ) then
		KHTvars["locked"] = false;
		KHunterTimersAnchor:Show();
	elseif( msg == "lock" ) then
		KHTvars["locked"] = true;
		KHunterTimersAnchor:Hide();
	elseif( string.find(msg, "colorchange" ) ) then
		for on in string.gmatch(msg, "colorchange (%a+)") do
			if( on == KHT_ON ) then
				KHTvars["colorchange"] = true;
			elseif( on == KHT_OFF ) then
				KHTvars["colorchange"] = false;
			end
			if( on == KHT_ON) or ( on == KHT_OFF ) then
				DEFAULT_CHAT_FRAME:AddMessage( "KHT: Colorchange is: "..on);
			end
		end
	elseif( string.find( msg, "barcolor" ) ) then
		for r, g, b in string.gmatch(msg, "barcolor ([%d.]+) ([%d.]+) ([%d.]+)") do
			local red, green, blue = unpack( KHTvars["barstartcolor"] );
			KHTvars["barstartcolor"][1] = r;
			KHTvars["barstartcolor"][2] = g;
			KHTvars["barstartcolor"][3] = b;
			
			local rd, gd, bd = unpack( KHTvars["bardelta"] );
			red = rd + red;
			blue = bd + blue;
			green = gd + green;
			
			red = red - r;
			green = green - g;
			blue = blue - b;
			
			KHTvars["bardelta"][1] = red;
			KHTvars["bardelta"][2] = green;
			KHTvars["bardelta"][3] = blue;
			DEFAULT_CHAT_FRAME:AddMessage( "KHT: Barcolor set to: "..KHTColor(r, g, b)..r..", "..g..", "..b.."|r");
		end
	elseif( string.find( msg, "barendcolor" ) ) then
		for red, green, blue in string.gmatch(msg, "barendcolor ([%d.]+) ([%d.]+) ([%d.]+)") do
			local r, g, b = unpack( KHTvars["barstartcolor"] );
			
			r = red - r;
			g = green - g;
			b = blue - b;
			
			KHTvars["bardelta"][1] = r;
			KHTvars["bardelta"][2] = g;
			KHTvars["bardelta"][3] = b;
			DEFAULT_CHAT_FRAME:AddMessage( "KHT: Barendcolor set to: "..KHTColor(red, green, blue)..red..", "..green..", "..blue.."|r");
		end
	elseif( string.find( msg, "flash" ) ) then
		for flash in string.gmatch( msg, "flash (%d+)" ) do
			flash = flash * 1;
			KHTvars["flash"] = flash;
			if( flash == 0 ) then
				DEFAULT_CHAT_FRAME:AddMessage("KHT: Bar flash "..KHT_OFF);
			else
				DEFAULT_CHAT_FRAME:AddMessage("KHT: Bar flash set to: "..flash.." seconds");
			end
		end
	elseif( string.find( msg, "step" ) ) then
		for step in string.gmatch( msg, "step ([%d.]+)" ) do
			KHTvars["step"] = step
			DEFAULT_CHAT_FRAME:AddMessage("KHT: Step set to: "..step);
		end
	elseif( msg == "resetpos" ) then
		KHunterTimersAnchor:ClearAllPoints();
		KHunterTimersAnchor:SetPoint("CENTER", "UIParent", "CENTER", 0, 0 );
	elseif( string.find( msg, "(%a+) (%d+)" ) ) then
		for cmd1, cmd2 in string.gmatch( msg, "(%a+) (%d+)" ) do
			--DEFAULT_CHAT_FRAME:AddMessage(cmd1.."-"..cmd2, 1, 0, 0);
			KHunterTimersFrame_add( cmd2, cmd1 );
		end
	elseif( msg == "status" ) then

		local statusstring = "";
		local statusstring1 = "";
		local statusstring2 = "";
		
		if( KHTvars[KHT_ON] ) then
			statusstring1 = KHT_ON;
		else
			statusstring1 = KHT_OFF;
		end
		DEFAULT_CHAT_FRAME:AddMessage(KHT_STATUS_STRINGS[1]);
		DEFAULT_CHAT_FRAME:AddMessage(format(KHT_STATUS_STRINGS[2], statusstring1));
		DEFAULT_CHAT_FRAME:AddMessage(format(KHT_STATUS_STRINGS[3], KHTvars["shotdelay"]));
		DEFAULT_CHAT_FRAME:AddMessage(format(KHT_STATUS_STRINGS[4], KHTvars["flash"], KHTvars["step"]));

		local r, g, b = unpack( KHTvars["barstartcolor"] );
		local rd, gd, bd = unpack( KHTvars["bardelta"] );
		statusstring1 = KHTColor(r,g,b)..r..", "..g..", "..b.."|r";
		statusstring2 = KHTColor(r+rd, g+gd, b+bd)..(r+rd)..", "..(b+bd)..", "..(g+gd).."|r";
		DEFAULT_CHAT_FRAME:AddMessage(format(KHT_STATUS_STRINGS[5], statusstring1, statusstring2));
		
		if( KHTvars["colorchange"] ) then
			statusstring1 = KHT_ON;
		else
			statusstring1 = KHT_OFF;
		end
		if( KHTvars["down"] ) then
			statusstring2 = "down";
		else
			statusstring2 = "up";
		end
		DEFAULT_CHAT_FRAME:AddMessage(format(KHT_STATUS_STRINGS[6], statusstring1, statusstring2));
		DEFAULT_CHAT_FRAME:AddMessage(format(KHT_STATUS_STRINGS[7], (KHTvars["scale"]/UIParent:GetScale()*100) ) );
	else
		for key,val in ipairs(KHT_SLASH_HELP) do
			DEFAULT_CHAT_FRAME:AddMessage(val, 1, 1, 0);
		end
	end
	
end

function KHunterTimersFrame_add( spellDuration, spellName, target )
	if( KHTvars["numBars"] < 0 ) then
		KHTvars["numBars"] = 0;
	end
	
	local allReadyActive = false;
	local bar;
	
	if( KHT_sfind( spellName, KHT_STING ) or string.find( spellName, KHT_CONC_SHOT ) ) then
		spellDuration = spellDuration + KHTvars["shotdelay"];
	end
	
	if( spellName == KHT_INTIM ) then
		--DEFAULT_CHAT_FRAME:AddMessage("Intim", 1, 1, 0 );
		if( khtPetIntim ) then
			--DEFAULT_CHAT_FRAME:AddMessage("Pet Intim", 1, 1, 0 );
			for num = 1, KHTvars["numBars"], 1 do
				local barframe = getglobal("KHunterTimersStatus"..num);
				local textBar = getglobal("KHunterTimersStatus"..num.."BarLeftText"):GetText();
				--DEFAULT_CHAT_FRAME:AddMessage("Intim: "..textBar, 1, 1, 0 );
				if( string.find( textBar, KHT_PET_INTIM ) ) then
					--barframe.endTime = 0;
					allReadyActive = true;
					bar = num;
					break;
				end
			end
		end
	elseif( string.find( spellName, KHT_PRIMED ) ) then
		if( trapTimer ) then
			for num = 1, KHTvars["numBars"], 1 do
				local textBar = getglobal("KHunterTimersStatus"..num.."BarLeftText"):GetText();
				--DEFAULT_CHAT_FRAME:AddMessage("Intim: "..textBar, 1, 1, 0 );
				if( string.find(textBar, KHT_PRIMED ) ) then
					allReadyActive = true;
					bar = num;
					break;
				end
			end
		end
	elseif( KHT_sfind( spellName, KHT_STING ) ) then
		for num = 1, KHTvars["numBars"] do
			local barframe = getglobal("KHunterTimersStatus"..num);
			if( KHT_sfind( barframe.spell, KHT_STING ) and ( barframe.target == target ) ) then
				allReadyActive = true;
				bar = num;
				break;
			end
		end
	elseif( KHT_sfind( spellName, KHT_HUNTERS_MARK ) ) then
		for num = 1, KHTvars["numBars"] do
			local barframe = getglobal("KHunterTimersStatus"..num);
			if( KHT_sfind( barframe.spell, KHT_HUNTERS_MARK ) ) then
				allReadyActive = true;
				bar = num;
				break;
			end
		end
	elseif( spellName == KHT_AUTO_SHOT ) and KHTvars["sticky"]  then
		if( KHunterTimersStatus1.spell == KHT_AUTO_SHOT ) then
			allReadyActive = true;
			bar = 1;
		else
			KHunterTimers_shift(1);
			allReadyActive = true;
			KHTvars["numBars"] = KHTvars["numBars"] + 1;
			bar = 1;
		end
	elseif( not string.find( spellName, KHT_FLARE ) ) then
		for num = 1, KHTvars["numBars"], 1 do
			local barframe = getglobal("KHunterTimersStatus"..num);
			if( barframe.spell == spellName ) and ( barframe.target == target ) then
				allReadyActive = true;
				bar = num;
				break;
			end
		end
	end
	
	local num = bar;
	if( allReadyActive ) then
		if( KHTvars["numBars"] == 0 ) then
			KHTvars["numBars"] = 1;
		end
	else
		if( KHTvars["numBars"] == 11 ) then
			return;
		end
		KHTvars["numBars"] = KHTvars["numBars"] + 1;
		num = KHTvars["numBars"];
	end
	
	local icon = getglobal("KHunterTimersStatus"..num.."Icon");
	local barframe = getglobal("KHunterTimersStatus"..num);
	local bar = getglobal("KHunterTimersStatus"..num.."Bar");
	local leftText = getglobal("KHunterTimersStatus"..num.."BarLeftText");
	local rightText = getglobal("KHunterTimersStatus"..num.."BarRightText");
	
	if( not barframe ) then
		--DEFAULT_CHAT_FRAME:AddMessage("WTFBBQ line 214");
		return;
	end
	local texture;
	if( spellName == KHT_IMP_CONC_SHORT ) then
		texture = KHTvars["textures"][KHT_CONC_SHOT];
	elseif( spellName == KHT_IMP_WC_SHORT ) then
		texture = KHTvars["textures"][KHT_WING_CLIP];
	elseif( string.find( spellName, KHT_TRAP ) ) then
		if( string.find( spellName, KHT_FREEZING_TRAP ) )then
			texture = KHTvars["textures"][KHT_FREEZING_TRAP]
		elseif( string.find( spellName, KHT_IMMO_TRAP ) ) then
			texture = KHTvars["textures"][KHT_IMMO_TRAP]
		elseif( string.find( spellName, KHT_FROST_TRAP ) ) then
			texture = KHTvars["textures"][KHT_FROST_TRAP]
		elseif( string.find( spellName, KHT_EXPL_TRAP ) ) then
			texture = KHTvars["textures"][KHT_EXPL_TRAP]
		elseif( string.find( spellName, KHT_SNAKE_TRAP ) ) then
			texture = KHTvars["textures"][KHT_SNAKE_TRAP]
		end
	elseif( string.find( spellName, KHT_PET_INTIM ) ) then
		texture = KHTvars["textures"][KHT_INTIM];
	elseif( spellName == KHT_AUTO_SHOT ) then
		texture = GetInventoryItemTexture("player", 18);
	else
		texture = KHTvars["textures"][spellName];
	end
	icon:SetTexture(texture);
	barframe.spell = spellName;
	barframe.texture = texture;
	barframe.target = target;
	barframe.startTime = GetTime();
	barframe.duration = spellDuration / 1000;
	barframe.endTime = barframe.startTime + barframe.duration;
	bar:SetMinMaxValues(barframe.startTime, barframe.endTime);
	bar:SetValue( barframe.endTime );
	local spellText = KHTColor(unpack(KHTvars["skillcolor"]))..spellName;
	if( KHTvars["append"] ) and (barframe.target) then
		spellText = spellText.."|r - "..KHTColor(unpack(KHTvars["targetcolor"]))..barframe.target;
	end
	leftText:SetText( spellText );
	local text;
	if( KHTvars["mili"] == 0 ) then
		text = string.format( KHTColor(unpack(KHTvars["timecolor"])).."%ds", barframe.duration );
	else
		text = string.format( KHTColor(unpack(KHTvars["timecolor"])).."%."..KHTvars["mili"].."f", barframe.duration );
	end
	rightText:SetText( text );
	barframe.channeling = true;
	barframe.fadeOut = false;
	KHunterTimersFrame:SetAlpha(KHTvars["overallalpha"]);
	KHT_SetHeight();
	if( not KHunterTimersFrame:IsVisible() ) then
		KHunterTimersFrame:Show();
	end
	local r, g, b, a = unpack( KHTvars["barstartcolor"] );
	bar:SetStatusBarColor(r, g, b, a );
	getglobal("KHunterTimersStatus"..num.."BGBar"):SetStatusBarColor(r, g, b, 0.25*a);
	barframe:SetAlpha(KHTvars["overallalpha"]);
	KHunterTimers_SetWidths();
	barframe:Show();
end

function KHunterTimers_SetWidths()	
	local largestwidth = 180;
	if( KHTvars["showtex"] ) then
		if( KHTvars["largetex"] ) and (KHTvars["barheight"] < 16 ) then
			largestwidth = largestwidth - 16;
		else
			largestwidth = largestwidth - KHTvars["barheight"];
		end
		if( KHTvars["gap"] ) then
			largestwidth = largestwidth - 5;
		end
	end
	local tarwidth = largestwidth;
	local extrawidth = 0;
	for i=1, KHTvars["numBars"] do
		local width = getglobal("KHunterTimersStatus"..i.."BarLeftText"):GetWidth() + getglobal("KHunterTimersStatus"..i.."BarRightText"):GetWidth();
		if( width > largestwidth ) then
			largestwidth = width;
		end
	end
	if( largestwidth > tarwidth ) and (not KHTvars["hidetext"]) then
		largestwidth = largestwidth + 40;
		if( KHTvars["showtex"] ) then
			extrawidth = KHTvars["barheight"];
			if( KHTvars["largetex"] ) and ( KHTvars["barheight"] < 16 ) then
				extrawidth = 16;
			end
			if( KHTvars["gap"] ) then
				extrawidth = extrawidth + 5;
			end
		end
		for i=1, KHTvars["numBars"] do
			getglobal("KHunterTimersStatus"..i):SetWidth(largestwidth + extrawidth);
			getglobal("KHunterTimersStatus"..i.."Bar"):SetWidth(largestwidth);
			getglobal("KHunterTimersStatus"..i.."BGBar"):SetWidth(largestwidth);
			getglobal("KHunterTimersStatus"..i.."BarTooltip"):SetWidth(largestwidth);
		end
		if( KHTvars["padding"] ) then
			KHunterTimersFrame:SetWidth(largestwidth + extrawidth + 20);
		else
			KHunterTimersFrame:SetWidth(largestwidth + extrawidth + 10);
		end
	else
		if( KHTvars["padding"] ) then
			KHunterTimersFrame:SetWidth( 240 );
		else
			KHunterTimersFrame:SetWidth( 230 );
		end
		local width = 220;
		if( KHTvars["showtex"] ) then
			if( KHTvars["largetex"] ) and ( KHTvars["barheight"] < 16) then
				width = width - 16;
			else
				width = width - KHTvars["barheight"];
			end
			if( KHTvars["gap"] ) then
				width = width - 5;
			end
		end
		for i=1, KHTvars["numBars"] do
			getglobal("KHunterTimersStatus"..i):SetWidth(220);
			getglobal("KHunterTimersStatus"..i.."Bar"):SetWidth(width);
			getglobal("KHunterTimersStatus"..i.."BGBar"):SetWidth(width);
			getglobal("KHunterTimersStatus"..i.."BarTooltip"):SetWidth(width);
		end
	end
end
			
			

function KHunterTimers_OnUpdateBar( id )
	if( not KHunterTimersFrame:IsVisible() ) then
		KHunterTimersFrame:Show();
	end

	if( IsControlKeyDown() ) then
		getglobal("KHunterTimersStatus"..id.."BarTooltip"):Show();
	else
		getglobal("KHunterTimersStatus"..id.."BarTooltip"):Hide();
	end

	local barframe = getglobal("KHunterTimersStatus"..id);
	if( barframe.channeling ) then
		local time = GetTime();
		local bartext = getglobal( "KHunterTimersStatus"..id.."BarRightText");
		local text = barframe.spell;

		if( time >= barframe.endTime ) then
			if( barframe.spell == KHT_AUTO_SHOT and khtAutoShot ) then
				return;
			end
			barframe.channeling = false;
			barframe.fadeOut = true;
			barframe.step = 0;
			barframe.target = nil;
			bartext:SetText( KHT_DONE );
			if( khtImpConc ) and ( text == KHT_IMP_CONC_SHORT ) then
				khtImpConc = false;
			elseif( khtRapidFire ) and ( text == KHT_RAPID_FIRE ) then
				khtRapidFire = false;
			elseif( khtQuickShots ) and ( text == KHT_QUICK_SHOTS ) then
				khtQuickShots = false;
			elseif( khtPetIntim ) and ( text == KHT_PET_INTIM ) then
				khtPetIntim = false;
			elseif( khtIntimidation ) and ( text == KHT_INTIM ) then
				khtIntimidation = false;
			elseif( trapTimer ) and string.find( text, KHT_PRIMED ) then
				trapTimer = false;
			elseif( khtWingClip ) and ( text == KHT_WING_CLIP ) then
				khtWingClip = false;
			elseif( khtImpWing ) and ( text == KHT_IMP_WC_SHORT ) then
				khtImpWing = false;
			elseif( khtFreezing ) and ( text == KHT_FREEZING_TRAP ) then
				khtFreezing = false;
			elseif( khtScatter ) and ( text == KHT_SCATTER ) then
				khtScatter = false;
			elseif( khtWyvern ) and ( text == KHT_WYVERN_TEXT ) then
				khtWyvern = false;
			elseif( khtFearBeast ) and ( text == KHT_FEAR_BEAST ) then
				khtFearBeast = false;
			elseif( khtExposeWeakness ) and ( text == KHT_EXPOSE_WEAKNESS ) then
				khtExposeWeakness = false;
			elseif( khtHuntersMark ) and ( text == KHT_HUNTERS_MARK ) then
				khtHuntersMark = false;
			elseif( khtPrimalBlessing ) and ( text == KHT_PRIMAL_BLESSING ) then
				khtPrimalBlessing = false;
			elseif( khtEntrapment ) and ( text == KHT_ENTRAPMENT ) then
				khtEntrapment = false;
			elseif( khtBerserking ) and ( text == KHT_BERSERKING ) then
				khtBerserking = false;
			elseif( khtJomGabbar ) and ( text == KHT_JOM_GABBAR ) then
				khtJomGabbar = false;
			elseif( khtSpider ) and ( text == KHT_KISS_SPIDER ) then
				khtSpider = false;
			elseif( khtFerocious ) and ( text == KHT_FEROCIOUS ) then
				khtFerocious = false;
			elseif( khtTactician ) and ( text == KHT_TACTICIAN ) then
				khtTactician = false;
			elseif( khtConcBarrage ) and ( text == KHT_CONC_BARRAGE ) then
				khtConcBarrage = false;
			elseif( khtWrath ) and ( text == KHT_WRATH ) then
				khtWrath = false;
			elseif( khtPetFrenzy ) and ( text == KHT_PET_FRENZY ) then
				khtPetFrenzy = false;
			elseif( khtHaste ) and ( text == KHT_HASTE ) then
				khtHaste = false;
			elseif( khtSkyguard ) and ( text == KHT_SKYGUARD ) then
				khtSkyguard = false;
			elseif( khtBeastLord ) and ( text == KHT_BEASTLORD ) then
				khtBeastLord = false;
			elseif( khtAshtongue ) and ( text == KHT_ASHTONGUE ) then
				khtAshtongue = false;
			end
			return;
		elseif ( khtQuickShots and text == KHT_QUICK_SHOTS and KHTvars["skills"][KHT_TALENT] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_QUICK_SHOTS ) and duration > 11 ) then
					KHunterTimersFrame_add( duration*1000, KHT_QUICK_SHOTS );
					break;
				end
				i = i + 1;
			end
		elseif ( khtPrimalBlessing and text == KHT_PRIMAL_BLESSING and KHTvars["skills"][KHT_SETITEM] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_PRIMAL_BLESSING ) and duration > 11 ) then
					KHunterTimersFrame_add( duration*1000, KHT_PRIMAL_BLESSING );
					break;
				end
				i = i + 1;
			end
		elseif ( khtFerocious and text == KHT_FEROCIOUS and KHTvars["skills"][KHT_TALENT] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_FEROCIOUS ) and duration > 9 ) then
					KHunterTimersFrame_add( duration*1000, KHT_FEROCIOUS );
					break;
				end
				i = i + 1;
			end
		elseif ( khtTactician and text == KHT_TACTICIAN and KHTvars["skills"][KHT_TALENT] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_TACTICIAN ) and duration > 7 ) then
					KHunterTimersFrame_add( duration*1000, KHT_TACTICIAN );
					break;
				end
				i = i + 1;
			end
		elseif ( khtWrath and text == KHT_WRATH and KHTvars["skills"][KHT_TRINKETS] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_WRATH ) and duration > 9 ) then
					KHunterTimersFrame_add( duration*1000, KHT_WRATH );
					break;
				end
				i = i + 1;
			end
		elseif ( khtPetFrenzy and text == KHT_PET_FRENZY and KHTvars["skills"][KHT_FRENZY] ) then
			local i = 1;
			while( UnitBuff("pet", i ) ) do
				local spellName, _, _, _, duration, timeLeft = UnitBuff("pet", i );
				if ( string.find( spellName, KHT_PET_FRENZY ) and timeLeft ~= nil ) then
					if ( timeLeft > 7 ) then
						KHunterTimersFrame_add( timeLeft*1000, KHT_PET_FRENZY );
						break;
					end
				end
				i = i + 1;
			end
		elseif ( khtHaste and text == KHT_HASTE and KHTvars["skills"][KHT_TRINKETS] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_HASTE ) and duration > 9 ) then
					KHunterTimersFrame_add( duration*1000, KHT_HASTE );
					break;
				end
				i = i + 1;
			end
		elseif ( khtSkyguard and text == KHT_SKYGUARD and KHTvars["skills"][KHT_TRINKETS] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_SKYGUARD ) and duration > 29 ) then
					KHunterTimersFrame_add( duration*1000, KHT_SKYGUARD );
					break;
				end
				i = i + 1;
			end
		elseif ( khtBeastLord and text == KHT_BEASTLORD and KHTvars["skills"][KHT_SETITEM] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_BEASTLORD ) and duration > 14 ) then
					KHunterTimersFrame_add( duration*1000, KHT_BEASTLORD );
					break;
				end
				i = i + 1;
			end
		elseif ( khtAshtongue and text == KHT_ASHTONGUE and KHTvars["skills"][KHT_TRINKETS] ) then
			local buffIndex;
			local i = 1;
			while true do
				buffIndex = GetPlayerBuff(i, "HELPFUL");
				if buffIndex == 0 then break end

				local spellName = GetPlayerBuffName(buffIndex);
				local duration  = GetPlayerBuffTimeLeft(buffIndex);

				if ( string.find( spellName, KHT_ASHTONGUE ) and duration > 7 ) then
					KHunterTimersFrame_add( duration*1000, KHT_ASHTONGUE );
					break;
				end
				i = i + 1;
			end
		end

		local bar = getglobal("KHunterTimersStatus"..id.."Bar");
		local value = barframe.startTime + barframe.endTime - time;
		bar:SetValue( value );
		local timeleft = barframe.duration - (time - barframe.startTime);
		local timeleftstring;
		if( KHTvars["mili"] == 0 ) then
			timeleftstring = string.format( KHTColor(unpack(KHTvars["timecolor"])).."%ds", timeleft );
		else
			timeleftstring = string.format( KHTColor(unpack(KHTvars["timecolor"])).."%."..KHTvars["mili"].."f", timeleft );
		end
		getglobal("KHunterTimersStatus"..id.."BarRightText"):SetText(timeleftstring);
		if( KHTvars["colorchange"] ) then
			local percent = (time - barframe.startTime)/(barframe.endTime - barframe.startTime);
			local r, g, b, a = unpack( KHTvars["barstartcolor"] );
			local redd, greend, blued, alphad = unpack( KHTvars["bardelta"] );
			redd = r + redd*percent;
			greend = g + greend*percent;
			blued = b + blued*percent;
			alphad = a + alphad*percent;
			bar:SetStatusBarColor( redd, greend, blued, alphad );
			getglobal("KHunterTimersStatus"..id.."BGBar"):SetStatusBarColor( redd, greend, blued, 0.25*alphad );
		end
		
		if( timeleft < KHTvars["flash"] ) and ( barframe.spell ~= KHT_AUTO_SHOT ) then
			if( barframe.step == 0 ) then
				barframe.step = -KHTvars["step"];
			end
			
			local alpha = barframe:GetAlpha() + barframe.step;
			if( alpha < 0.2 ) then
				barframe.step = KHTvars["step"];
			elseif( alpha > KHTvars["overallalpha"] ) then
				barframe.step = -KHTvars["step"];
			end
			barframe:SetAlpha(alpha);
		end
			
			
	elseif( barframe.fadeOut ) then
		local alpha = barframe:GetAlpha() - 0.05;
		if( alpha > 0 ) then
			barframe:SetAlpha(alpha);
		else
			barframe.fadeOut = false;
			barframe:Hide();
			KHTvars["numBars"] = KHTvars["numBars"] - 1;
			KHunterTimers_AutoCascade( 1, false );
		end
	end
end

function KHunterTimersFrame_OnUpdate(elapsed)
	if( (elapsed - this.updateTime) > 1 ) then
		this.updateTime = elapsed;
		
		KHunterTimersFrame:SetScale( KHTvars["scale"] );
		for i=1, KHT_NUM_BARS do
			getglobal("KHunterTimersStatus"..i):SetScale( KHTvars["scale"] );
		end
--		for key, val in pairs(dimin) do
--			if( (elapsed - dimin[key]["time"]) > 20 ) then
--				dimin[key] = nil;
--			end
--		end
		KHT_SetHeight();
	end
	
	if ( KHTvars["numBars"] > 0 ) then
		KHunterTimersFrame:Show();
		KHunterTimersFrame:SetAlpha( KHTvars["overallalpha"] );
	else
		local alpha = KHunterTimersFrame:GetAlpha() - 0.05;
		if( alpha > 0 ) then
			KHunterTimersFrame:SetAlpha(alpha);
		else
			KHunterTimersFrame:Hide();
		end
	end
end
function KHT_init()
	if( not KHTvars ) then
		KHTvars = {};
		KHTvars["bg"] = { r=0, g=0, b=0, a=7 };
	end
	if( KHTvars[KHT_ON] == nil ) then
		KHTvars[KHT_ON] = true;
	end
	if( not KHTvars["borderalpha"] ) then
		KHTvars["borderalpha"] = {
			[1] = 1;
			[2] = 1;
			[3] = 1;
			[4] = 1;
		};
	end
	KHunterTimersFrame:SetBackdropColor( KHTvars["bg"].r, KHTvars["bg"].g, KHTvars["bg"].b, KHTvars["bg"].a );
	KHunterTimersFrame:SetBackdropBorderColor( unpack(KHTvars["borderalpha"]) );
	KHTvars["numBars"] = 0;

	if( not KHTvars["skills"] ) then
		KHTvars["skills"] = {};
	end

	if( KHTvars["version"] == nil ) then
		KHTvars["skills"] = {};
		KHTvars["version"] = 2.0;
	end
	
	for i=1, KHT_NUM_TIMERS do
		if( KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] == nil ) then
			KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] = true;
		end
	end
	
	if( not KHTvars["shotdelay"] ) then
		KHTvars["shotdelay"] = 200;
	end

	if( not KHTvars["scale"] ) then
		KHTvars["scale"] = UIParent:GetScale();
	end
	
	if( KHTvars["locked"] == nil ) then
		KHTvars["locked"] = false;
	end
	
	if( not KHTvars["locked"] ) then
		KHunterTimersAnchor:Show();
	else
		KHunterTimersAnchor:Hide();
	end
	
	if( not KHTvars["mili"] ) then
		KHTvars["mili"] = 1;
	end
	
	if( KHTvars["flash"] == nil ) then
		KHTvars["flash"] = 5;
	end
	
	if( not KHTvars["skillcolor"] ) then
		local r, g, b = KHunterTimersStatus1BarLeftText:GetTextColor();
		--local a = KHunterTimersStatus1BarLeftText:GetAlpha();
		KHTvars["skillcolor"] = {
			[1] = r,
			[2] = g,
			[3] = b,
			[4] = 1
		};
	end
	
	if( not KHTvars["timecolor"] ) then
		local r, g, b = KHunterTimersStatus1BarRightText:GetTextColor();
		KHTvars["timecolor"] = {
			[1] = r,
			[2] = g,
			[3] = b,
			[4] = 1
		};
	end
	
	if( not KHTvars["targetcolor"] ) then
		local r, g, b = KHunterTimersStatus1BarLeftText:GetTextColor();
		KHTvars["targetcolor"] = {
			[1] = r,
			[2] = g,
			[3] = b,
			[4] = 1
		};
	end
	
	if( not KHTvars["barstartcolor"] ) then
		KHTvars["barstartcolor"] = {
			[1] = 0,
			[2] = 0.8,
			[3] = 0,
			[4] = 1 };
	end
	if( not KHTvars["barstartcolor"][4] ) then
		KHTvars["barstartcolor"][4] = 1;
	end
	if( not KHTvars["bardelta"] ) then
		KHTvars["bardelta"] = {
			[1] = 0.8,
			[2] = -0.8,
			[3] = 0,
			[4] = 0};
	end
	if( not KHTvars["bardelta"][4] ) then
		KHTvars["bardelta"][4] = 0;
	end
	if( KHTvars["step"] == nil ) then
		KHTvars["step"] = 0.03;
	end
	if( KHTvars["colorchange"] == nil ) then
		KHTvars["colorchange"] = false;
	end
	if( not KHTvars["bardistance"] ) then
		KHTvars["bardistance"] = 10;
	end
	
	if( KHTvars["down"] == nil ) then
		KHTvars["down"] = true;
	end
	
	if( KHTvars["append"] == nil ) then
		KHTvars["append"] = false;
	end
	
	if( not KHTvars["overallalpha"] ) then
		KHTvars["overallalpha"] = 1;
	end
	
	KHunterTimers_ClearActiveSpells();
	
	for i=1, KHT_NUM_TIMERS do --Check boxes
		getglobal("KHunterTimersOptionsTimersCheckButton"..i.."Text"):SetText(KHT_OPTIONS_TIMERS[i]);
	end
	
	for i=1, KHT_NUM_OPTIONS do --Check boxes
		getglobal("KHunterTimersOptionsBarsCheckButton"..i.."Text"):SetText(KHT_OPTIONS_BARS[i]);
	end
	
	for i=1, KHT_NUM_SLIDERS do  --Sliders
		getglobal("KHunterTimersOptionsBarsSlider"..i.."SliderTitle"):SetText(KHT_OPTIONS_SLIDER[i]);
		getglobal("KHunterTimersOptionsBarsSlider"..i.."SliderLow"):SetText(KHT_OPTIONS_SLIDER_ENDS[i][1])
		getglobal("KHunterTimersOptionsBarsSlider"..i.."SliderHigh"):SetText(KHT_OPTIONS_SLIDER_ENDS[i][2]);
	end
	
	if( not KHTvars["textures"] ) then
		KHTvars["textures"] = {};
	end
	
	if( KHTvars["showtex"] == nil ) then
		KHTvars["showtex"] = true;
	end
	if( KHTvars["largetex"] == nil ) then
		KHTvars["largetex"] = true;
	end
	
	if( KHTvars["hidetext"] == nil ) then
		KHTvars["hidetext"] = false;
	end
	
	if( KHTvars["hidetime"] == nil ) then
		KHTvars["hidetime"] = false;
	end
	
	if( KHTvars["gap"] == nil ) then
		KHTvars["gap"] = true;
	end
	
	if( KHTvars["padding"] == nil ) then
		KHTvars["padding"] = true;
	end
	
	if( not KHTvars["barheight"] ) then
		KHTvars["barheight"] = 10;
	end
	
	if( KHTvars["sticky"] == nil ) then
		KHTvars["sticky"] = true;
	end
	
	if( KHTvars["traptimemult"] == nil ) then
		KHTvars["traptimemult"] = 1;
	end
	
	getglobal("KHunterTimersOptionsTimersLabel1Label"):SetText(KHT_OPTIONS_TIMERS_TEXT);

	for i=1, KHT_NUM_LABELS do
		getglobal("KHunterTimersOptionsBarsLabel"..i.."Label"):SetText(KHT_OPTIONS_LABELS[i]);
	end
	
	getglobal("KHunterTimersOptionsTitleString"):SetText("Kharthus's Hunter Timers "..KHT_VERSION);
	
	KHunterTimers_SetSettings();
	
	KHunterTimersOptions:SetScale(UIParent:GetScale()*0.8);
end

function KHunterTimersFrame_OnEvent(event, arg1, arg2, arg3, arg4)
	if( event == "ADDON_ACTION_BLOCKED" or event == "ADDON_ACTION_FORBIDDEN" ) then
		if ( arg1 == "ItemRack" or arg1 == "CT_RaidAssist" ) then
		elseif ( khtDebugBC ) then
			DEFAULT_CHAT_FRAME:AddMessage(event.." "..arg1.." "..arg2, 1, 0, 0 );
		end
		return;
	end
	if ( khtDebug ) then
		if ( arg4 ) then
			DEFAULT_CHAT_FRAME:AddMessage(event.." "..arg1.." "..arg2.." "..arg3.." "..arg4, 1, 0, 0 );
		elseif ( arg3 ) then
			DEFAULT_CHAT_FRAME:AddMessage(event.." "..arg1.." "..arg2.." "..arg3, 1, 0, 0 );
		elseif ( arg2 ) then
			DEFAULT_CHAT_FRAME:AddMessage(event.." "..arg1.." "..arg2, 1, 0, 0 );
		elseif ( arg1 ) then
			DEFAULT_CHAT_FRAME:AddMessage(event.." "..arg1, 1, 0, 0 );
		else
			DEFAULT_CHAT_FRAME:AddMessage(event, 1, 0, 0 );
		end
	end
	
	if( event == "VARIABLES_LOADED" ) then
		KHT_init();
		return;
	end
	if( event == "SPELLS_CHANGED" ) then
		KHunterTimers_UpdateSpells();
		return;
	end
	if( event == "CHARACTER_POINTS_CHANGED" or event == "PLAYER_ALIVE" ) then
		local _, _, _, _, rank = GetTalentInfo( 3, 8 ); --Clever traps
		KHTvars["traptimemult"] = 1 + (rank * 0.15);
		return;
	end
	if( not KHTvars[KHT_ON] ) then
		return;
	end

--	if( event == "UNIT_SPELLCAST_SENT") then
--		DEFAULT_CHAT_FRAME:AddMessage(arg1.." "..arg2.." "..arg3.." "..arg4);
--	end
	if( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE" ) or ( event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE" ) then
		if( string.find( arg1, KHT_TRAP ) ) then
			if( trapTimer ) then
				for mob, effect in string.gmatch( arg1, KHT_TRAP_AFFLICT_STRING ) do
					--DEFAULT_CHAT_FRAME:AddMessage(effect.." "..mob);
					KHunterTimers_addDebuff( effect, mob );
				end
			end
		elseif( string.find( arg1, KHT_FEAR_BEAST ) ) then
			for mob, effect in string.gmatch( arg1, KHT_AFFLICT_STRING ) do
				--DEFAULT_CHAT_FRAME:AddMessage(effect.." "..mob);
				if( string.find(effect, KHT_FEAR_BEAST) ) and ( mob == UnitName("target") ) then
					khtFearBeast = true;
					KHunterTimers_addDebuff( KHT_FEAR_BEAST, mob );
				end
			end
		elseif( string.find( arg1, KHT_EXPOSE_WEAKNESS ) ) then
			for mob, effect in string.gmatch( arg1, KHT_AFFLICT_STRING ) do
				--DEFAULT_CHAT_FRAME:AddMessage(effect.." "..mob);
				if( string.find(effect, KHT_EXPOSE_WEAKNESS) ) and ( mob == UnitName("target") ) then
					khtExposeWeakness = true;
					KHunterTimers_addDebuff( KHT_EXPOSE_WEAKNESS, mob );
				end
			end
		elseif( string.find( arg1, KHT_ENTRAPMENT ) ) then
			for mob, effect in string.gmatch( arg1, KHT_AFFLICT_STRING ) do
				--DEFAULT_CHAT_FRAME:AddMessage(effect.." "..mob);
				if( string.find(effect, KHT_ENTRAPMENT) ) and ( mob == UnitName("target") ) then
					khtEntrapment = true;
					KHunterTimers_addDebuff( KHT_ENTRAPMENT, mob );
				end
			end
		elseif( string.find( arg1, KHT_CONC_BARRAGE ) ) then
			for mob, effect in string.gmatch( arg1, KHT_AFFLICT_STRING ) do
				--DEFAULT_CHAT_FRAME:AddMessage(effect.." "..mob);
				if( string.find(effect, KHT_CONC_BARRAGE) ) and ( mob == UnitName("target") ) then
					khtExposeWeakness = true;
					KHunterTimers_addDebuff( KHT_CONC_BARRAGE, mob );
				end
			end
		end
	elseif( event == "CHAT_MSG_SPELL_PET_DAMAGE" ) then
		if( string.find( arg1, KHT_RESIST ) or string.find( arg1, KHT_IMMUNE) ) then
			if( string.find( arg1, KHT_INTIM ) ) then
				for i=1, KHTvars["numBars"] do
					local text = getglobal("KHunterTimersStatus"..i).spell;
					if( string.find( text, KHT_PET_INTIM ) ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			else
				for trap in string.gmatch( arg1, KHT_FIND_TRAP_FAILED ) do
					if( trapTimer ) and ( string.find( trap, KHT_FREEZING_TRAP ) or string.find( trap, KHT_IMMO_TRAP ) )then
						for i=1, KHTvars["numBars"] do
							local text = getglobal("KHunterTimersStatus"..i.."BarLeftText"):GetText();
							if( string.find( text, trap.." "..KHT_PRIMED ) ) then
								getglobal("KHunterTimersStatus"..i).endTime = 0;
							end
						end
					end
				end
			end
		end
	elseif( event == "CHAT_MSG_SPELL_SELF_DAMAGE" ) then
		if(KHTvars["skills"][KHT_WING_CLIP]) and ( string.find( arg1, KHT_YOUR..KHT_WING_CLIP ) ) and ( string.find( arg1, KHT_HITS ) or string.find(arg1, KHT_CRITS ) ) then
			khtWingClip = true;
			local name = UnitName("target");
			KHunterTimersFrame_add( 10000, KHT_WING_CLIP, name );
		elseif( string.find( arg1, KHT_FAILED ) ) then
			local name = UnitName("target");
			for spell in string.gmatch( arg1, KHT_FAILED_STRING) do
				--DEFAULT_CHAT_FRAME:AddMessage(spell);
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal("KHunterTimersStatus"..i);
					if( barframe.spell == spell ) and ( barframe.target == name )then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			end
		elseif( string.find(arg1, KHT_MISSES ) ) then
			local name = UnitName("target");
			for spell in string.gmatch( arg1, KHT_MISSES_STRING ) do
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal("KHunterTimersStatus"..i);
					if( barframe.spell == spell ) and ( barframe.target == name )then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			end
		elseif(KHTvars["skills"][KHT_COUNTER]) and ( string.find( arg1, KHT_YOUR..KHT_COUNTER ) and (string.find( arg1, KHT_HITS ) or string.find( arg1, KHT_CRITS )) )then
			KHunterTimersFrame_add( 5000, KHT_COUNTER, UnitName("target") );
		elseif( string.find( arg1, KHT_SNAKE_TRAP ) ) then
			if( trapTimer ) then
				KHunterTimers_addDebuff( KHT_SNAKE_TRAP );
			end
		end
	elseif( event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" or event == "CHAT_MSG_COMBAT_XP_GAIN" ) then
		if( KHTvars["numBars"] > 0 ) then
			for target in string.gmatch( arg1, KHT_DIES ) do
				for num = 1, KHTvars["numBars"], 1 do
					local barframe = getglobal("KHunterTimersStatus"..num);
					if( barframe.target ~= nil ) then
--						DEFAULT_CHAT_FRAME:AddMessage(event.." "..target.." "..barframe.target);
						if ( string.find( target, barframe.target, 1, true ) ) then
--							DEFAULT_CHAT_FRAME:AddMessage(event.." "..target.." "..barframe.target);
							if( barframe.spell ~= KHT_FREEZING_TRAP ) then
								barframe.endTime = 0;
							end
						end
					end
				end
			end
		end
	elseif( event == "CHAT_MSG_MONSTER_EMOTE" ) then
		if( KHTvars["skills"][KHT_FRENZY] and (string.find(arg1, KHT_FRENZY_EMOTE ) or string.find(arg1, KHT_FRENZY_FLAMEGOR ) )) then
			if( arg2 == KHT_CHROMAGGUS ) then
				KHunterTimersFrame_add( 15000, KHT_FRENZY, KHT_CHROMAGGUS );
			elseif( arg2 == KHT_FLAMEGOR ) then
				KHunterTimersFrame_add( 10000, KHT_FRENZY, KHT_FLAMEGOR );
			elseif( arg2 == KHT_MAGMADAR ) then
				KHunterTimersFrame_add( 15000, KHT_FRENZY, KHT_MAGMADAR );
			elseif( arg2 == KHT_HUHURAN ) then
				KHunterTimersFrame_add( 10000, KHT_FRENZY, KHT_HUHURAN );
			elseif( arg2 == KHT_GLUTH ) then
				KHunterTimersFrame_add( 10000, KHT_FRENZY, KHT_GLUTH );
			end
		end
	elseif( event == "UNIT_SPELLCAST_SENT" ) then
		local name = UnitName("target");
		if( KHTvars["skills"][KHT_HUNTERS_MARK]) and ( string.find( arg2, KHT_HUNTERS_MARK ) ) then
			if ( name ~= nil and name ~= "Unknown" ) then
				khtHuntersMark = true;
				KHunterTimers_addDebuff( KHT_HUNTERS_MARK, name );
			end
		end
	elseif( event == "UNIT_SPELLCAST_SUCCEEDED" ) then
		--DEFAULT_CHAT_FRAME:AddMessage(arg1.." "..arg2.." "..arg3);

		local name = UnitName("target");
		if( KHT_sfind( arg2, KHT_STING ) ) then
			KHunterTimers_addDebuff( arg2, name );
		elseif( KHTvars["skills"][KHT_INTIM]) and ( string.find( arg2, KHT_INTIM ) ) then
			khtPetIntim = true;
			KHunterTimersFrame_add( 15000, KHT_PET_INTIM );
		elseif( KHTvars["skills"][KHT_BW]) and ( string.find( arg2, KHT_BW ) ) then
			KHunterTimersFrame_add( 18000, arg2 );
		elseif( KHTvars["skills"][KHT_FLARE]) and ( string.find( arg2, KHT_FLARE ) ) then
			KHunterTimersFrame_add( 20000, arg2 );
--		elseif( KHTvars["skills"][KHT_HUNTERS_MARK]) and ( string.find( arg2, KHT_HUNTERS_MARK ) ) then
--			if ( name ~= nil ) then
--				khtHuntersMark = true;
--				KHunterTimers_addDebuff( KHT_HUNTERS_MARK, name );
--			end
		elseif( string.find( arg2, KHT_TRAP ) ) then
			if( KHTvars["skills"][arg2]) then
				trapTimer = true;
				if ( string.find( arg2, KHT_FREEZING_TRAP ) ) then
					trapRank = string.match( arg3, "%d" );
				end
				KHunterTimersFrame_add( 60000, arg2.." "..KHT_PRIMED );
			end
		elseif( KHTvars["skills"][KHT_SCATTER]) and ( string.find( arg2, KHT_SCATTER ) ) then
			local duration = 4000;
--			if(name) and ( dimin[name] ) and ((GetTime() - dimin[name]["time"]) < 20) then
--				for i=1, dimin[name]["times"] do
--					duration = duration/2;
--				end
--			end
			khtScatter = true;
			KHunterTimersFrame_add( duration, arg2, name );
		elseif( KHTvars["skills"][KHT_CONC_SHOT]) and ( arg2 == KHT_CONC_SHOT ) then
			KHunterTimers_addDebuff( arg2, name );
		elseif( KHTvars["skills"][KHT_AUTO_SHOT]) and ( arg2 == KHT_AUTO_SHOT ) then
			khtAutoShot = true;
			khtTimeLeft = UnitRangedDamage("player");
			KHunterTimersFrame_add( khtTimeLeft*1000, KHT_AUTO_SHOT );
		elseif( KHTvars["skills"][KHT_SILENCE_SHOT]) and ( arg2 == KHT_SILENCE_SHOT ) then
			KHunterTimersFrame_add( 3000, arg2 );
		elseif( KHTvars["skills"][KHT_FEED_PET]) and ( arg2 == KHT_FEED_PET ) then
			KHunterTimersFrame_add( 20000, arg2 );
		elseif( KHTvars["skills"][KHT_MEND_PET]) and ( arg2 == KHT_MEND_PET ) then
			KHunterTimersFrame_add( 15000, arg2 );
		elseif( KHTvars["skills"][KHT_MISDIRECTION]) and ( arg2 == KHT_MISDIRECTION ) then
			KHunterTimersFrame_add( 30000, arg2 );
		else
			KHunterTimers_addDebuff( arg2, name );
		end
	
	elseif( event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" ) then
		if( string.find( arg1, KHT_QUICK_SHOTS ) ) then
			khtQuickShots = true;
			if ( KHTvars["skills"][KHT_TALENT] ) then
				KHunterTimersFrame_add( 12000, KHT_QUICK_SHOTS );
			end
		elseif( string.find( arg1, KHT_PRIMAL_BLESSING ) ) then
			khtPrimalBlessing = true;
			if ( KHTvars["skills"][KHT_SETITEM] ) then
				KHunterTimersFrame_add( 12000, KHT_PRIMAL_BLESSING );
			end
		elseif( string.find( arg1, KHT_DETERRENCE ) ) then
			if ( KHTvars["skills"][KHT_DETERRENCE] ) then
				KHunterTimersFrame_add( 10000, KHT_DETERRENCE );
			end
		elseif( string.find( arg1, KHT_BERSERKING ) ) then
			khtBerserking = true;
			if ( KHTvars["skills"][KHT_RACIALS] ) then
				KHunterTimersFrame_add( 10000, KHT_BERSERKING );
			end
		elseif( string.find( arg1, KHT_DEVILSAUR ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 20000, KHT_DEVILSAUR );
			end
		elseif( string.find( arg1, KHT_ZHM ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 20000, KHT_ZHM );
			end
		elseif( string.find( arg1, KHT_EARTHSTRIKE ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 20000, KHT_EARTHSTRIKE );
			end
		elseif( string.find( arg1, KHT_SWARMGUARD ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_SWARMGUARD );
			end
		elseif( string.find( arg1, KHT_JOM_GABBAR ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] and not khtJomGabbar ) then
				KHunterTimersFrame_add( 20000, KHT_JOM_GABBAR );
				khtJomGabbar = true;
			end
		elseif( string.find( arg1, KHT_KISS_SPIDER ) ) then
			khtSpider = true;
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 15000, KHT_KISS_SPIDER );
			end
		elseif( string.find( arg1, KHT_RAPID_KILLING ) ) then
			if ( KHTvars["skills"][KHT_TALENT] ) then
				KHunterTimersFrame_add( 20000, KHT_RAPID_KILLING );
			end
		elseif( string.find( arg1, KHT_FEROCIOUS ) ) then
			khtFerocious = true;
			if ( KHTvars["skills"][KHT_TALENT] ) then
				KHunterTimersFrame_add( 10000, KHT_FEROCIOUS );
			end
		elseif( string.find( arg1, KHT_BLOOD_FURY ) ) then
			if ( KHTvars["skills"][KHT_RACIALS] ) then
				KHunterTimersFrame_add( 15000, KHT_BLOOD_FURY );
			end
		elseif( string.find( arg1, KHT_FEROCITY ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 15000, KHT_FEROCITY );
			end
		elseif( string.find( arg1, KHT_TACTICIAN ) ) then
			khtTactician = true;
			if ( KHTvars["skills"][KHT_TALENT] ) then
				KHunterTimersFrame_add( 8000, KHT_TACTICIAN );
			end
		elseif( string.find( arg1, KHT_BURNING_HATRED ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 15000, KHT_BURNING_HATRED );
			end
		elseif( string.find( arg1, KHT_ANCIENT_POWER ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 20000, KHT_ANCIENT_POWER );
			end
		elseif( string.find( arg1, KHT_SANTOS ) ) then
			if ( KHTvars["skills"][KHT_SETITEM] ) then
				KHunterTimersFrame_add( 10000, KHT_SANTOS );
			end
		elseif( string.find( arg1, KHT_NIGHTSEYE ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 12000, KHT_NIGHTSEYE );
			end
		elseif( string.find( arg1, KHT_UNRAVELLER ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 10000, KHT_UNRAVELLER );
			end
		elseif( string.find( arg1, KHT_LUST ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 20000, KHT_LUST );
			end
		elseif( string.find( arg1, KHT_HASTE ) ) then
			khtHaste = true;
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 10000, KHT_HASTE );
			end
		elseif( string.find( arg1, KHT_HEROISM ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 15000, KHT_HEROISM );
			end
		elseif( string.find( arg1, KHT_HEROIC ) ) then
			if ( KHTvars["skills"][KHT_SETITEM] ) then
				KHunterTimersFrame_add( 15000, KHT_HEROIC );
			end
		elseif( string.find( arg1, KHT_SKYFIRE ) ) then
			if ( KHTvars["skills"][KHT_SETITEM] ) then
				KHunterTimersFrame_add( 6000, KHT_SKYFIRE );
			end
		elseif( string.find( arg1, KHT_TSUNAMI ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 10000, KHT_TSUNAMI );
			end
		elseif( string.find( arg1, KHT_ASHTONGUE ) ) then
			khtAshtongue = true;
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 8000, KHT_ASHTONGUE );
			end
		elseif( string.find( arg1, KHT_WRATH ) ) then
			khtWrath = true;
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 10000, KHT_WRATH );
			end
		elseif( string.find( arg1, KHT_DELUSIONAL ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_DELUSIONAL );
			end
		elseif( string.find( arg1, KHT_KLEPTOMANIA ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_KLEPTOMANIA );
			end
		elseif( string.find( arg1, KHT_MANIC ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_MANIC );
			end
		elseif( string.find( arg1, KHT_MARTYR ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_MARTYR );
			end
		elseif( string.find( arg1, KHT_NARCISSISM ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_NARCISSISM );
			end
		elseif( string.find( arg1, KHT_PARANOIA ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_PARANOIA );
			end
		elseif( string.find( arg1, KHT_TALON ) ) then
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 6000, KHT_TALON );
			end
		elseif( string.find( arg1, KHT_PET_FRENZY ) ) then
			khtPetFrenzy = true;
			if ( KHTvars["skills"][KHT_FRENZY] ) then
				KHunterTimersFrame_add( 8000, KHT_PET_FRENZY );
			end
		elseif( string.find( arg1, KHT_SKYGUARD ) ) then
			khtSkyguard = true;
			if ( KHTvars["skills"][KHT_TRINKETS] ) then
				KHunterTimersFrame_add( 30000, KHT_SKYGUARD );
			end
		elseif( string.find( arg1, KHT_BEASTLORD ) ) then
			khtBeastLord = true;
			if ( KHTvars["skills"][KHT_SETITEM] ) then
				KHunterTimersFrame_add( 15000, KHT_BEASTLORD );
			end
		end

	elseif( event == "PLAYER_AURAS_CHANGED" ) then
		local buffIndex;
		local i = 1;
		while true do
			buffIndex = GetPlayerBuff(i, "HELPFUL");
			if buffIndex == 0 then break end

			local spellName = GetPlayerBuffName(buffIndex);
			local duration  = GetPlayerBuffTimeLeft(buffIndex);
--			DEFAULT_CHAT_FRAME:AddMessage(i.." "..buffIndex.." "..spellName.." "..duration);
			duration = duration * 1000;

			if ( string.find( spellName, KHT_RAPID_FIRE ) ) then
				if ( KHTvars["skills"][KHT_RAPID_FIRE] and not khtRapidFire ) then
					KHunterTimersFrame_add( duration, KHT_RAPID_FIRE );
				end
				khtRapidFire = true;
				break;
			end
			i = i + 1;
		end

	elseif( event == "UNIT_AURA" ) then
		if( arg1 == "target" ) then
			local name = UnitName("target");
			local i = 1;
			while( UnitDebuff("target", i ) ) do
				local spellName, _, _, count, _, duration, timeLeft = UnitDebuff("target", i );
				
				if( string.find( spellName, KHT_INTIM ) ) and ( not khtIntimidation ) then
					khtIntimidation = true;
					KHunterTimers_addDebuff( KHT_INTIM, name );
				elseif( string.find( spellName, KHT_IMP_CONC ) ) and ( not khtImpConc ) then
					khtImpConc = true;
					KHunterTimers_addDebuff( KHT_IMP_CONC_SHORT, name );
				elseif( string.find( spellName, KHT_IMP_WC ) ) and ( not khtImpWing ) then
					khtImpWing = true;
					KHunterTimersFrame_add( 5000, KHT_IMP_WC_SHORT, name );
				elseif( string.find( spellName, KHT_EXPOSE_WEAKNESS ) ) and ( not khtExposeWeakness ) then
					khtExposeWeakness = true;
					KHunterTimers_addDebuff( KHT_EXPOSE_WEAKNESS, name );
				elseif( string.find( spellName, KHT_CONC_BARRAGE ) ) and ( not khtConcBarrage ) then
					khtConcBarrage = true;
					KHunterTimers_addDebuff( KHT_CONC_BARRAGE, name );
--				elseif( string.find( spellName, KHT_HUNTERS_MARK ) ) then
--					DEFAULT_CHAT_FRAME:AddMessage("HM: "..count.." "..duration.." "..timeLeft);
				end
				i = i + 1;
			end
		end
	elseif( event == "CHAT_MSG_SPELL_AURA_GONE_OTHER" ) then
		for effect, target in string.gmatch(arg1, KHT_FADE_STRING ) do

			if( khtFreezing ) and string.find(effect, KHT_FREEZING_TRAP ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_FREEZING_TRAP ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
--				if( not dimin[target] ) then
--					dimin[target] = {};
--				end
--				dimin[target]["time"] = GetTime();
--				if( dimin[target]["times"] == nil ) then
--					dimin[target]["times"] = 1;
--				else
--					dimin[target]["times"] = dimin[target]["times"] + 1;
--				end
			elseif( khtScatter ) and string.find( effect, KHT_SCATTER ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i)
					if( barframe.spell == KHT_SCATTER ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
						
					end
				end
--				if( not dimin[target] ) then
--					dimin[target] = {};
--				end
--				dimin[target]["time"] = GetTime();
--				if( dimin[target]["times"] == nil ) then
--					dimin[target]["times"] = 1;
--				else
--					dimin[target]["times"] = dimin[target]["times"] + 1;
--				end
			elseif( khtFearBeast ) and string.find( effect, KHT_FEAR_BEAST ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_FEAR_BEAST ) and (barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtWyvern ) and string.find( effect, KHT_WYVERN ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					local text = getglobal("KHunterTimersStatus"..i.."BarLeftText"):GetText();
					if( text == KHT_WYVERN_TEXT ) and (barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
--				if( not dimin[target] ) then
--					dimin[target] = {};
--				end
--				dimin[target]["time"] = GetTime();
--				if( dimin[target]["times"] == nil ) then
--					dimin[target]["times"] = 1;
--				else
--					dimin[target]["times"] = dimin[target]["times"] + 1;
--				end
			elseif( khtWingClip ) and string.find( effect, KHT_WING_CLIP ) and not ( string.find( effect, KHT_IMP_WC ) ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_WING_CLIP ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtExposeWeakness ) and string.find( effect, KHT_EXPOSE_WEAKNESS ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_EXPOSE_WEAKNESS ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtEntrapment ) and string.find( effect, KHT_ENTRAPMENT ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_ENTRAPMENT ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtHuntersMark ) and string.find( effect, KHT_HUNTERS_MARK ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_HUNTERS_MARK ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtConcBarrage ) and string.find( effect, KHT_CONC_BARRAGE ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_CONC_BARRAGE ) and ( barframe.target == target ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			end
		end
	elseif( event == "CHAT_MSG_SPELL_AURA_GONE_SELF" ) then
		--DEFAULT_CHAT_FRAME:AddMessage(event.." "..arg1, 1, 0, 0);
		for effect, target in string.gmatch(arg1, KHT_FADE_STRING ) do
			if( khtQuickShots ) and string.find( effect, KHT_QUICK_SHOTS ) then
				khtQuickShots = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_QUICK_SHOTS ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtRapidFire ) and string.find( effect, KHT_RAPID_FIRE ) then
				khtRapidFire = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_RAPID_FIRE ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtPrimalBlessing ) and string.find( effect, KHT_PRIMAL_BLESSING ) then
				khtPrimalBlessing = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_PRIMAL_BLESSING ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtBerserking ) and string.find( effect, KHT_BERSERKING ) then
				khtBerserking = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_BERSERKING ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtSpider ) and string.find( effect, KHT_KISS_SPIDER ) then
				khtSpider = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_KISS_SPIDER ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( string.find( effect, KHT_RAPID_KILLING ) ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_RAPID_KILLING ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtFerocious ) and string.find( effect, KHT_FEROCIOUS ) then
				khtFerocious = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_FEROCIOUS ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( string.find( effect, KHT_MISDIRECTION ) ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_MISDIRECTION ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( string.find( effect, KHT_FEED_PET ) ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_FEED_PET ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( string.find( effect, KHT_MEND_PET ) ) then
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_MEND_PET ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtTactician ) and string.find( effect, KHT_TACTICIAN ) then
				khtTactician = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_TACTICIAN ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtWrath ) and string.find( effect, KHT_WRATH ) then
				khtWrath = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_WRATH ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtPetFrenzy ) and string.find( effect, KHT_PET_FRENZY ) then
				khtPetFrenzy = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_PET_FRENZY ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtHaste ) and string.find( effect, KHT_HASTE ) then
				khtHaste = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_HASTE ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtSkyguard ) and string.find( effect, KHT_SKYGUARD ) then
				khtSkyguard = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_SKYGUARD ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtBeastLord ) and string.find( effect, KHT_BEASTLORD ) then
				khtBeastLord = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_BEASTLORD ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			elseif( khtAshtongue ) and string.find( effect, KHT_ASHTONGUE ) then
				khtAshtongue = false;
				for i=1, KHTvars["numBars"] do
					local barframe = getglobal( "KHunterTimersStatus"..i);
					if( barframe.spell == KHT_ASHTONGUE ) then
						getglobal("KHunterTimersStatus"..i).endTime = 0;
					end
				end
			end
		end
	elseif( event == "START_AUTOREPEAT_SPELL" ) then
		khtAutoShot = true;
	elseif( event == "STOP_AUTOREPEAT_SPELL" ) then
		khtAutoShot = false;
	end

end

function KHunterTimers_addDebuff( debuff, mob )
	if (KHTvars["skills"][KHT_SERPENT]) and ( debuff == KHT_SERPENT ) then
		KHunterTimersFrame_add( 15000, KHT_SERPENT, mob );
		--currentSting = "Serpent Sting";
	elseif(KHTvars["skills"][KHT_SCORPID]) and ( debuff == KHT_SCORPID ) then
		KHunterTimersFrame_add( 20000, KHT_SCORPID, mob );
		--currentSting = "Scorpid Sting";
	elseif(KHTvars["skills"][KHT_VIPER]) and ( debuff == KHT_VIPER ) then
		KHunterTimersFrame_add( 8000, KHT_VIPER, mob );
		--currentSting = "Viper Sting";
	elseif(KHTvars["skills"][KHT_WYVERN]) and ( debuff == KHT_WYVERN ) then
		local duration = 12000;
		local name = UnitName("target");
--		if( dimin[name] ) and ( ( GetTime() - dimin[name]["time"]) < 20 )then
--			for i=1, dimin[name]["times"] do
--				duration = duration / 2;
--			end
--		end
		khtWyvern = true;
		KHunterTimersFrame_add( duration, KHT_WYVERN_TEXT, name );
	elseif(KHTvars["skills"][KHT_CONC_SHOT]) and ( debuff == KHT_IMP_CONC_SHORT ) then
		KHunterTimersFrame_add( 3000, KHT_IMP_CONC_SHORT, mob );
	elseif(KHTvars["skills"][KHT_FEAR_BEAST] ) and ( debuff == KHT_FEAR_BEAST ) then
		KHunterTimersFrame_add( 20000, KHT_FEAR_BEAST, mob );
	elseif(KHTvars["skills"][KHT_CONC_SHOT]) and ( debuff == KHT_CONC_SHOT ) then
		KHunterTimersFrame_add( 4000, KHT_CONC_SHOT, mob );
	elseif(KHTvars["skills"][KHT_HUNTERS_MARK]) and ( debuff == KHT_HUNTERS_MARK ) then
		KHunterTimersFrame_add( 120000, KHT_HUNTERS_MARK, mob );
	elseif(KHTvars["skills"][KHT_INTIM]) and ( debuff == KHT_INTIM ) then
		KHunterTimersFrame_add( 3000, KHT_INTIM, mob );
	elseif(KHTvars["skills"][KHT_TALENT] or KHTvars["skills"][KHT_SETITEM]) and ( debuff == KHT_EXPOSE_WEAKNESS ) then
		KHunterTimersFrame_add( 7000, KHT_EXPOSE_WEAKNESS, mob );
	elseif(KHTvars["skills"][KHT_ENTRAPMENT]) and ( debuff == KHT_ENTRAPMENT ) then
		KHunterTimersFrame_add( 5000, KHT_ENTRAPMENT, mob );
	elseif(KHTvars["skills"][KHT_TALENT] and debuff == KHT_CONC_BARRAGE ) then
		KHunterTimersFrame_add( 4000, KHT_CONC_BARRAGE, mob );
	elseif( string.find( debuff, KHT_TRAP ) ) then
		for num = 1, KHTvars["numBars"] do
			local barframe = getglobal( "KHunterTimersStatus"..num);
			local text = getglobal("KHunterTimersStatus"..num.."BarLeftText"):GetText();
			if( string.find( text, KHT_PRIMED ) ) then
				barframe.endTime = 0;
			end
		end
		if(KHTvars["skills"][KHT_FREEZING_TRAP]) and ( string.find( debuff, KHT_FREEZING_TRAP ) ) then
			khtFreezing = true;
			local duration = (5000 + trapRank*5000)*KHTvars["traptimemult"];
--				if(mob) and ( dimin[mob] ) and ( ( GetTime() - dimin[mob]["time"]) < 20 )then
--					for i=1, dimin[mob]["times"] do
--						duration = duration / 2;
--					end
--				end
			KHunterTimersFrame_add( duration, KHT_FREEZING_TRAP, mob );
		elseif(KHTvars["skills"][KHT_FROST_TRAP]) and ( string.find( debuff, KHT_FROST_TRAP ) ) then
			KHunterTimersFrame_add( 30000*KHTvars["traptimemult"], KHT_FROST_TRAP.." "..KHT_AURA );
		elseif(KHTvars["skills"][KHT_IMMO_TRAP]) and ( string.find( debuff, KHT_IMMO_TRAP ) ) then
			KHunterTimersFrame_add( 15000, KHT_IMMO_TRAP, mob );
		elseif(KHTvars["skills"][KHT_EXPL_TRAP]) and ( string.find( debuff, KHT_EXPL_TRAP ) ) then
			KHunterTimersFrame_add( 20000, KHT_EXPL_TRAP.." "..KHT_AURA );
		elseif(KHTvars["skills"][KHT_SNAKE_TRAP]) and ( string.find( debuff, KHT_SNAKE_TRAP ) ) then
			KHunterTimersFrame_add( 15000, KHT_SNAKE_TRAP.." "..KHT_AURA );
		end
	end
end
function KHunterTimers_cascadeBar( id )
	local barframefrom = getglobal("KHunterTimersStatus"..(id+1));
	if( not barframefrom ) or not ( barframefrom:IsVisible() and (barframefrom.channeling or barframefrom.fadeOut) )then
		getglobal("KHunterTimersStatus"..id):Hide();
		KHunterTimers_SetWidths();
		KHT_SetHeight();
		return;
	end
	
	local barframeto = getglobal("KHunterTimersStatus"..id);
	local barto = getglobal("KHunterTimersStatus"..id.."Bar");
	local textLeftto = getglobal("KHunterTimersStatus"..id.."BarLeftText");
	local textRightto = getglobal("KHunterTimersStatus"..id.."BarRightText");
	local iconto = getglobal("KHunterTimersStatus"..id.."Icon");
	
	id = id + 1;
	
	local barfrom = getglobal("KHunterTimersStatus"..id.."Bar");
	local textLeftfrom = getglobal("KHunterTimersStatus"..id.."BarLeftText");
	local textRightfrom = getglobal("KHunterTimersStatus"..id.."BarRightText");
	
	barframeto.texture = barframefrom.texture;
	iconto:SetTexture(barframeto.texture);
	
	barframeto.startTime = barframefrom.startTime;
	barframeto.endTime = barframefrom.endTime;
	barframeto.duration = barframefrom.duration;
	barframeto.channeling = barframefrom.channeling;
	barframeto.fadeOut = barframefrom.fadeOut;
	barframeto.target = barframefrom.target;
	barframeto.spell = barframefrom.spell;
	barto:SetMinMaxValues(barframeto.startTime, barframeto.endTime);
	barto:SetValue(barfrom:GetValue());
	textLeftto:SetText(textLeftfrom:GetText());
	textRightto:SetText(textRightfrom:GetText());
	barframeto:SetAlpha(barframefrom:GetAlpha());
	barframeto:Show();
	KHunterTimers_cascadeBar( id );
end

function KHunterTimers_shift( id, curr )

	if( id > KHTvars["numBars"] ) or ( KHTvars["numBars"] == 11 ) then
		return;
	end
	
	if( not curr ) then
		curr = KHTvars["numBars"] + 1;
	end
	
	if( curr == id ) then
		--DEFAULT_CHAT_FRAME:AddMessage("shiftend");
		return;
	end
	
	KHunterTimers_CopyBar( curr, curr-1 );
	KHunterTimers_shift( id, curr-1 );
	
end

function KHunterTimers_CopyBar(to, from)
	local barframeto = getglobal("KHunterTimersStatus"..to);
	local barto = getglobal("KHunterTimersStatus"..to.."Bar");
	local textLeftto = getglobal("KHunterTimersStatus"..to.."BarLeftText");
	local textRightto = getglobal("KHunterTimersStatus"..to.."BarRightText");
	local iconto = getglobal("KHunterTimersStatus"..to.."Icon");
	
	local barframefrom = getglobal("KHunterTimersStatus"..from);
	local barfrom = getglobal("KHunterTimersStatus"..from.."Bar");
	local textLeftfrom = getglobal("KHunterTimersStatus"..from.."BarLeftText");
	local textRightfrom = getglobal("KHunterTimersStatus"..from.."BarRightText");
	
	barframeto.texture = barframefrom.texture;
	iconto:SetTexture(barframeto.texture);
	
	barframeto.startTime = barframefrom.startTime;
	barframeto.endTime = barframefrom.endTime;
	barframeto.duration = barframefrom.duration;
	barframeto.channeling = barframefrom.channeling;
	barframeto.fadeOut = barframefrom.fadeOut;
	barframeto.target = barframefrom.target;
	barframeto.spell = barframefrom.spell;
	barto:SetMinMaxValues(barframeto.startTime, barframeto.endTime);
	barto:SetValue(barfrom:GetValue());
	textLeftto:SetText(textLeftfrom:GetText());
	textRightto:SetText(textRightfrom:GetText());
	barframeto:SetAlpha(barframefrom:GetAlpha());
	barframeto:Show();
end

function KHunterTimers_AutoCascade(id, last)
	if( id == KHT_NUM_BARS ) then
		return;
	end
	if( id == 0 ) then
		id = 1;
	end
	local barframe = getglobal("KHunterTimersStatus"..id);
	if( barframe:IsVisible() ) then
		KHunterTimers_AutoCascade(id+1, false);
	else
		local barframenext = getglobal("KHunterTimersStatus"..id+1);
		if( barframenext:IsVisible() ) then
			KHunterTimers_cascadeBar(id);
			if( last ) then
				KHunterTimers_AutoCascade( id-1, true );
			else
				KHunterTimers_AutoCascade( id+1, false );
			end
		else
			KHunterTimers_AutoCascade(id+1, true);
		end
	end
end

function KHunterTimers_ShowOptions()
	for i=1, KHT_NUM_TIMERS do
		if( KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] ) then
			getglobal("KHunterTimersOptionsTimersCheckButton"..i):SetChecked(1);
		else
			getglobal("KHunterTimersOptionsTimersCheckButton"..i):SetChecked(0);
		end
	end
	
	if( KHTvars[KHT_ON] ) then
		KHunterTimersOptionsBarsCheckButtonOn:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButtonOn:SetChecked(0);
	end
	
	if( KHTvars["locked"] ) then
		KHunterTimersOptionsBarsCheckButton1:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton1:SetChecked(0);
	end
	
	if( KHTvars["colorchange"] ) then
		KHunterTimersOptionsBarsCheckButton2:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton2:SetChecked(0);
	end
	
	if( KHTvars["showtex"] ) then
		KHunterTimersOptionsBarsCheckButton3:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton3:SetChecked(0);
	end
	
	if( KHTvars["largetex"] ) then
		KHunterTimersOptionsBarsCheckButton4:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton4:SetChecked(0);
	end
	
	if( KHTvars["gap"] ) then
		KHunterTimersOptionsBarsCheckButton5:SetChecked(0);
	else
		KHunterTimersOptionsBarsCheckButton5:SetChecked(1);
	end

	if( KHTvars["append"] ) then
		KHunterTimersOptionsBarsCheckButton6:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton6:SetChecked(0);
	end

	if( KHTvars["padding"] ) then
		KHunterTimersOptionsBarsCheckButton7:SetChecked(0);
	else
		KHunterTimersOptionsBarsCheckButton7:SetChecked(1);
	end
	
	if( KHTvars["hidetext"] ) then
		KHunterTimersOptionsBarsCheckButton8:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton8:SetChecked(0);
	end

	if( KHTvars["hidetime"] ) then
		KHunterTimersOptionsBarsCheckButton9:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton9:SetChecked(0);
	end

	if( KHTvars["sticky"] ) then
		KHunterTimersOptionsBarsCheckButton10:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton10:SetChecked(0);
	end

	if( KHTvars["down"] ) then
		KHunterTimersOptionsBarsCheckButton11:SetChecked(1);
	else
		KHunterTimersOptionsBarsCheckButton11:SetChecked(0);
	end

	KHunterTimersOptionsBarsEditBox1:SetText(KHTvars["shotdelay"]);
	
	local r, g, b, a = unpack(KHTvars["barstartcolor"]);
	local rd, gd, bd, ad = unpack( KHTvars["bardelta"] );
	rd = rd + r;
	gd = gd + g;
	bd = bd + b;
	ad = ad + a;
	KHunterTimersOptionsBarsColor1Swatch:SetVertexColor(r, g, b);
	KHunterTimersOptionsBarsColor1Swatch.r = r;
	KHunterTimersOptionsBarsColor1Swatch.g = g;
	KHunterTimersOptionsBarsColor1Swatch.b = b;
	KHunterTimersOptionsBarsColor1Swatch.a = a;
	KHunterTimersOptionsBarsColor2Swatch:SetVertexColor(rd, gd, bd);
	KHunterTimersOptionsBarsColor2Swatch.r = rd;
	KHunterTimersOptionsBarsColor2Swatch.g = gd;
	KHunterTimersOptionsBarsColor2Swatch.b = bd;
	KHunterTimersOptionsBarsColor2Swatch.a = ad;
	KHunterTimersOptionsBarsColor3Swatch:SetVertexColor(KHTvars["bg"].r, KHTvars["bg"].g, KHTvars["bg"].b, KHTvars["bg"].a);
	KHunterTimersOptionsBarsColor3Swatch.r = KHTvars["bg"].r;
	KHunterTimersOptionsBarsColor3Swatch.g = KHTvars["bg"].g;
	KHunterTimersOptionsBarsColor3Swatch.b = KHTvars["bg"].b;
	KHunterTimersOptionsBarsColor3Swatch.a = KHTvars["bg"].a;
	KHunterTimersOptionsBarsColor4Swatch:SetVertexColor( unpack( KHTvars["borderalpha"]) );
	KHunterTimersOptionsBarsColor4Swatch.r, KHunterTimersOptionsBarsColor4Swatch.g, KHunterTimersOptionsBarsColor4Swatch.b, KHunterTimersOptionsBarsColor4Swatch.a = unpack( KHTvars["borderalpha"] );
	KHunterTimersOptionsBarsColor5Swatch:SetVertexColor(unpack(KHTvars["skillcolor"]));
	KHunterTimersOptionsBarsColor5Swatch.r, KHunterTimersOptionsBarsColor5Swatch.g, KHunterTimersOptionsBarsColor5Swatch.b, KHunterTimersOptionsBarsColor5Swatch.a = unpack( KHTvars["skillcolor"] );
	KHunterTimersOptionsBarsColor6Swatch:SetVertexColor(unpack(KHTvars["timecolor"]));
	KHunterTimersOptionsBarsColor6Swatch.r, KHunterTimersOptionsBarsColor6Swatch.g, KHunterTimersOptionsBarsColor6Swatch.b, KHunterTimersOptionsBarsColor6Swatch.a = unpack( KHTvars["timecolor"] );
	KHunterTimersOptionsBarsColor7Swatch:SetVertexColor(unpack(KHTvars["targetcolor"]));
	KHunterTimersOptionsBarsColor7Swatch.r, KHunterTimersOptionsBarsColor7Swatch.g, KHunterTimersOptionsBarsColor7Swatch.b, KHunterTimersOptionsBarsColor7Swatch.a = unpack( KHTvars["targetcolor"] );
	
	KHunterTimersOptionsBarsSlider1Slider:SetValue(KHTvars["bardistance"]);
	KHunterTimersOptionsBarsSlider2Slider:SetValue(KHTvars["scale"]/UIParent:GetScale());
	KHunterTimersOptionsBarsSlider3Slider:SetValue(KHTvars["mili"]);
	KHunterTimersOptionsBarsSlider4Slider:SetValue(KHTvars["flash"]);
	KHunterTimersOptionsBarsSlider5Slider:SetValue(KHTvars["step"]);
	KHunterTimersOptionsBarsSlider6Slider:SetValue(KHTvars["overallalpha"]);
	KHunterTimersOptionsBarsSlider7Slider:SetValue(KHTvars["barheight"]);
	
	KHunterTimersOptions:Show();
end

function KHunterTimers_SaveOptions()

	for i=1, KHT_NUM_TIMERS do
		if( getglobal("KHunterTimersOptionsTimersCheckButton"..i):GetChecked() == 1 ) then
			KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] = true;
		else
			KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] = false;
		end
	end
	
	if( KHunterTimersOptionsBarsCheckButtonOn:GetChecked() == 1 ) then
		KHTvars[KHT_ON] = true;
	else
		KHTvars[KHT_ON] = false;
	end
	
	if( KHunterTimersOptionsBarsCheckButton1:GetChecked() == 1 ) then
		KHTvars["locked"] = true;
		KHunterTimersAnchor:Hide();
	else
		KHTvars["locked"] = false;
		KHunterTimersAnchor:Show();
	end
	
	if( KHunterTimersOptionsBarsCheckButton2:GetChecked() == 1 ) then
		KHTvars["colorchange"] = true;
	else
		KHTvars["colorchange"] = false;
	end
	
	if( KHunterTimersOptionsBarsCheckButton3:GetChecked() == 1 ) then
		KHTvars["showtex"] = true;
	else
		KHTvars["showtex"] = false;
	end

	if( KHunterTimersOptionsBarsCheckButton4:GetChecked() == 1 ) then
		KHTvars["largetex"] = true;
	else
		KHTvars["largetex"] = false;
	end

	if( KHunterTimersOptionsBarsCheckButton5:GetChecked() == 1 ) then
		KHTvars["gap"] = false;
	else
		KHTvars["gap"] = true;
	end

	if( KHunterTimersOptionsBarsCheckButton6:GetChecked() == 1 ) then
		KHTvars["append"] = true;
	else
		KHTvars["append"] = false;
	end

	if( KHunterTimersOptionsBarsCheckButton7:GetChecked() == 1 ) then
		KHTvars["padding"] = false;
	else
		KHTvars["padding"] = true;
	end
	
	if( KHunterTimersOptionsBarsCheckButton8:GetChecked() == 1 ) then
		KHTvars["hidetext"] = true;
	else
		KHTvars["hidetext"] = false;
	end

	if( KHunterTimersOptionsBarsCheckButton9:GetChecked() == 1 ) then
		KHTvars["hidetime"] = true;
	else
		KHTvars["hidetime"] = false;
	end

	if( KHunterTimersOptionsBarsCheckButton10:GetChecked() == 1 ) then
		KHTvars["sticky"] = true;
	else
		KHTvars["sticky"] = false;
	end

	if( KHunterTimersOptionsBarsCheckButton11:GetChecked() == 1 ) then
		KHTvars["down"] = true;
	else
		KHTvars["down"] = false;
	end

	KHTvars["shotdelay"] = 1*KHunterTimersOptionsBarsEditBox1:GetText();
	
	KHTvars["barstartcolor"][1] = KHunterTimersOptionsBarsColor1Swatch.r; 
	KHTvars["barstartcolor"][2] = KHunterTimersOptionsBarsColor1Swatch.g; 
	KHTvars["barstartcolor"][3] = KHunterTimersOptionsBarsColor1Swatch.b;
	KHTvars["barstartcolor"][4] = KHunterTimersOptionsBarsColor1Swatch.a;
	KHTvars["bardelta"][1] = KHunterTimersOptionsBarsColor2Swatch.r - KHunterTimersOptionsBarsColor1Swatch.r;
	KHTvars["bardelta"][2] = KHunterTimersOptionsBarsColor2Swatch.g - KHunterTimersOptionsBarsColor1Swatch.g;
	KHTvars["bardelta"][3] = KHunterTimersOptionsBarsColor2Swatch.b - KHunterTimersOptionsBarsColor1Swatch.b;
	KHTvars["bardelta"][4] = KHunterTimersOptionsBarsColor2Swatch.a - KHunterTimersOptionsBarsColor1Swatch.a;
	KHTvars["borderalpha"][1] = KHunterTimersOptionsBarsColor4Swatch.r;
	KHTvars["borderalpha"][2] = KHunterTimersOptionsBarsColor4Swatch.g;
	KHTvars["borderalpha"][3] = KHunterTimersOptionsBarsColor4Swatch.b;
	KHTvars["borderalpha"][4] = KHunterTimersOptionsBarsColor4Swatch.a;
	KHTvars["skillcolor"][1] = KHunterTimersOptionsBarsColor5Swatch.r;
	KHTvars["skillcolor"][2] = KHunterTimersOptionsBarsColor5Swatch.g;
	KHTvars["skillcolor"][3] = KHunterTimersOptionsBarsColor5Swatch.b;
	KHTvars["skillcolor"][4] = KHunterTimersOptionsBarsColor5Swatch.a;
	KHTvars["timecolor"][1] = KHunterTimersOptionsBarsColor6Swatch.r;
	KHTvars["timecolor"][2] = KHunterTimersOptionsBarsColor6Swatch.g;
	KHTvars["timecolor"][3] = KHunterTimersOptionsBarsColor6Swatch.b;
	KHTvars["timecolor"][4] = KHunterTimersOptionsBarsColor6Swatch.a;
	KHTvars["targetcolor"][1] = KHunterTimersOptionsBarsColor7Swatch.r;
	KHTvars["targetcolor"][2] = KHunterTimersOptionsBarsColor7Swatch.g;
	KHTvars["targetcolor"][3] = KHunterTimersOptionsBarsColor7Swatch.b;
	KHTvars["targetcolor"][4] = KHunterTimersOptionsBarsColor7Swatch.a;
	
	KHTvars["bg"].r = KHunterTimersOptionsBarsColor3Swatch.r;
	KHTvars["bg"].g = KHunterTimersOptionsBarsColor3Swatch.g;
	KHTvars["bg"].b = KHunterTimersOptionsBarsColor3Swatch.b;
	KHTvars["bg"].a = KHunterTimersOptionsBarsColor3Swatch.a;
	
	KHTvars["bardistance"] = KHunterTimersOptionsBarsSlider1Slider:GetValue();
	KHTvars["scale"] = KHunterTimersOptionsBarsSlider2Slider:GetValue()*UIParent:GetScale();
	KHTvars["mili"] = KHunterTimersOptionsBarsSlider3Slider:GetValue();
	KHTvars["flash"] = KHunterTimersOptionsBarsSlider4Slider:GetValue();
	KHTvars["step"] = KHunterTimersOptionsBarsSlider5Slider:GetValue();
	KHTvars["overallalpha"] = KHunterTimersOptionsBarsSlider6Slider:GetValue();
	KHTvars["barheight"] = KHunterTimersOptionsBarsSlider7Slider:GetValue();
	
	KHunterTimers_SetSettings();
	
end

function KHunterTimers_SaveCloseOptions()
	
	KHunterTimers_SaveOptions();
	KHunterTimersOptions:Hide();

end

function KHunterTimers_ResetOptions()

	KHTvars = {};
	
	KHTvars["version"] = 2.0;

	KHTvars["bg"] = { r=0, g=0, b=0, a=7 };

	KHTvars[KHT_ON] = true;

	KHTvars["borderalpha"] = {
		[1] = 1;
		[2] = 1;
		[3] = 1;
		[4] = 1;
	};

	KHunterTimersFrame:SetBackdropColor( KHTvars["bg"].r, KHTvars["bg"].g, KHTvars["bg"].b, KHTvars["bg"].a );
	KHunterTimersFrame:SetBackdropBorderColor( unpack(KHTvars["borderalpha"]) );
	KHTvars["numBars"] = 0;

	KHTvars["skills"] = {};

	for i=1, KHT_NUM_TIMERS do
		if( KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] == nil ) then
			KHTvars["skills"][KHT_OPTIONS_TIMERS[i]] = true;
		end
	end
	
	KHTvars["shotdelay"] = 200;

	KHTvars["scale"] = UIParent:GetScale();

	KHTvars["locked"] = false;
	KHunterTimersAnchor:Show();

	KHTvars["bardistance"] = 10;

	KHTvars["down"] = true;

	KHTvars["mili"] = 1;

	KHTvars["flash"] = 5;
	
	local r, g, b = KHunterTimersStatus1BarLeftText:GetTextColor();
	KHTvars["skillcolor"] = {
		[1] = r,
		[2] = g,
		[3] = b,
		[4] = 1
	};

	local r, g, b = KHunterTimersStatus1BarRightText:GetTextColor();
	KHTvars["timecolor"] = {
		[1] = r,
		[2] = g,
		[3] = b,
		[4] = 1
	};

	local r, g, b = KHunterTimersStatus1BarLeftText:GetTextColor();
	KHTvars["targetcolor"] = {
		[1] = r,
		[2] = g,
		[3] = b,
		[4] = 1
	};

	KHTvars["barstartcolor"] = {
		[1] = 0,
		[2] = 0.8,
		[3] = 0,
		[4] = 1
	};

	KHTvars["bardelta"] = {
		[1] = 0.8,
		[2] = -0.8,
		[3] = 0,
		[4] = 0};

	KHTvars["step"] = 0.03;

	KHTvars["colorchange"] = false;

	KHTvars["append"] = false;

	KHTvars["overallalpha"] = 1;
	
	KHunterTimers_ClearActiveSpells();
	
	for i=1, KHT_NUM_TIMERS do --Check boxes
		getglobal("KHunterTimersOptionsTimersCheckButton"..i.."Text"):SetText(KHT_OPTIONS_TIMERS[i]);
	end
	
	for i=1, KHT_NUM_OPTIONS do --Check boxes
		getglobal("KHunterTimersOptionsBarsCheckButton"..i.."Text"):SetText(KHT_OPTIONS_BARS[i]);
	end
	
	for i=1, KHT_NUM_SLIDERS do  --Sliders
		getglobal("KHunterTimersOptionsBarsSlider"..i.."SliderTitle"):SetText(KHT_OPTIONS_SLIDER[i]);
		getglobal("KHunterTimersOptionsBarsSlider"..i.."SliderLow"):SetText(KHT_OPTIONS_SLIDER_ENDS[i][1])
		getglobal("KHunterTimersOptionsBarsSlider"..i.."SliderHigh"):SetText(KHT_OPTIONS_SLIDER_ENDS[i][2]);
	end
	
	KHTvars["textures"] = {};
	KHunterTimers_UpdateSpells();
	
	KHTvars["showtex"] = true;

	KHTvars["largetex"] = true;

	KHTvars["hidetext"] = false;

	KHTvars["hidetime"] = false;

	KHTvars["gap"] = true;

	KHTvars["padding"] = true;

	KHTvars["barheight"] = 10;

	KHTvars["sticky"] = true;
	
	local _, _, _, _, rank = GetTalentInfo( 3, 8 ); --Clever traps
	KHTvars["traptimemult"] = 1 + (rank * 0.15);
	
	getglobal("KHunterTimersOptionsTimersLabel1Label"):SetText(KHT_OPTIONS_TIMERS_TEXT);

	for i=1, KHT_NUM_LABELS do
		getglobal("KHunterTimersOptionsBarsLabel"..i.."Label"):SetText(KHT_OPTIONS_LABELS[i]);
	end
	
	getglobal("KHunterTimersOptionsTitleString"):SetText("Kharthus's Hunter Timers "..KHT_VERSION);
	
	KHunterTimers_SetSettings();
	
end

function KHunterTimers_SetSettings()
	
	KHunterTimersFrame:SetBackdropColor(KHTvars["bg"].r, KHTvars["bg"].g, KHTvars["bg"].b, KHTvars["bg"].a);
	KHunterTimersFrame:SetBackdropBorderColor(unpack(KHTvars["borderalpha"] ) );
	
	for i=1, KHT_NUM_BARS do
		local barframe = getglobal("KHunterTimersStatus"..i);
		local bar = getglobal( "KHunterTimersStatus"..i.."Bar");
		local bg = getglobal( "KHunterTimersStatus"..i.."BGBar");
		local tt = getglobal( "KHunterTimersStatus"..i.."BarTooltip");
		local barwidth = 220;
		
		barframe:SetHeight( KHTvars["barheight"] );
		bar:SetHeight( KHTvars["barheight"] );
		bg:SetHeight( KHTvars["barheight"] );
		tt:SetHeight( KHTvars["barheight"] );
		local icon = getglobal("KHunterTimersStatus"..i.."Icon");
		if( KHTvars["showtex"] ) then
			
			icon:Show();
			if( KHTvars["gap"] ) then
				barwidth = barwidth - 5;
			end
			if( KHTvars["largetex"] ) and ( KHTvars["barheight"] < 16) then
				barframe:SetHeight(16);
				icon:SetHeight(16);
				icon:SetWidth(16);
				barwidth = barwidth - 16;
			else
				icon:SetHeight( KHTvars["barheight"] );
				icon:SetWidth( KHTvars["barheight"] );
				barwidth = barwidth - KHTvars["barheight"];
			end
			
			bar:ClearAllPoints();
			if( KHTvars["gap"] ) then
				bar:SetPoint("LEFT", "KHunterTimersStatus"..i.."Icon", "RIGHT", 5, 0 );
			else
				bar:SetPoint("LEFT", "KHunterTimersStatus"..i.."Icon", "RIGHT", 0, 0 );
			end
			bg:ClearAllPoints();
			if( KHTvars["gap"] ) then
				bg:SetPoint("LEFT", "KHunterTimersStatus"..i.."Icon", "RIGHT", 5, 0 );
			else
				bg:SetPoint("LEFT", "KHunterTimersStatus"..i.."Icon", "RIGHT", 0, 0 );
			end
			tt:ClearAllPoints();
			if( KHTvars["gap"] ) then
				tt:SetPoint("LEFT", "KHunterTimersStatus"..i.."Icon", "RIGHT", 5, 0 );
			else
				tt:SetPoint("LEFT", "KHunterTimersStatus"..i.."Icon", "RIGHT", 0, 0 );
			end
		else
			icon:Hide();
			bar:SetPoint("LEFT", "KHunterTimersStatus"..i, "LEFT", 0, 0 );
			bg:SetPoint("LEFT", "KHunterTimersStatus"..i, "LEFT", 0, 0 );
			tt:SetPoint("LEFT", "KHunterTimersStatus"..i, "LEFT", 0, 0 );
		end
		barframe:SetWidth(220);
		bar:SetWidth(barwidth);
		bg:SetWidth(barwidth);
		tt:SetWidth(barwidth);
		if( KHTvars["hidetext"] ) then
			getglobal("KHunterTimersStatus"..i.."BarLeftText"):Hide();
		else
			getglobal("KHunterTimersStatus"..i.."BarLeftText"):Show();
		end
		if( KHTvars["hidetime"] ) then
			getglobal("KHunterTimersStatus"..i.."BarRightText"):Hide();
		else
			getglobal("KHunterTimersStatus"..i.."BarRightText"):Show();
		end
	end
	
	
	local height;
	local padding;
	if( not KHTvars["largetex"] ) or ( KHTvars["barheight"] >= 16 ) then
		height = KHTvars["numBars"] * (KHTvars["barheight"] + KHTvars["bardistance"]) - KHTvars["bardistance"] + 10;
	else
		height = KHTvars["numBars"] * (16 + KHTvars["bardistance"]) - KHTvars["bardistance"] + 10;
	end
	
	if( KHTvars["padding"] ) then
		KHunterTimersFrame:SetWidth( 240 );
		padding = 10;
		height = height + 10;
	else
		KHunterTimersFrame:SetWidth( 230 );
		padding = 5;
	end
	
	KHunterTimersFrame:SetHeight(height);
	
	if( KHTvars["down"] ) then
		KHunterTimersFrame:ClearAllPoints();
		KHunterTimersFrame:SetPoint( "TOPLEFT", "KHunterTimersAnchor", "BOTTOMLEFT" );
		KHunterTimersStatus1:ClearAllPoints();
		KHunterTimersStatus1:SetPoint( "TOPLEFT", "KHunterTimersFrame", "TOPLEFT", padding, -padding );
		for i=2, KHT_NUM_BARS do
			getglobal("KHunterTimersStatus"..i):ClearAllPoints();
			getglobal("KHunterTimersStatus"..i):SetPoint( "TOP", "KHunterTimersStatus"..(i-1), "BOTTOM", 0, -KHTvars["bardistance"] );
		end
	else
		KHunterTimersFrame:ClearAllPoints();
		KHunterTimersFrame:SetPoint( "BOTTOMLEFT", "KHunterTimersAnchor", "TOPLEFT" );
		KHunterTimersStatus1:ClearAllPoints();
		KHunterTimersStatus1:SetPoint( "BOTTOMLEFT", "KHunterTimersFrame", "BOTTOMLEFT", padding, padding );
		for i=2, KHT_NUM_BARS do
			getglobal("KHunterTimersStatus"..i):ClearAllPoints();
			getglobal("KHunterTimersStatus"..i):SetPoint( "BOTTOM", "KHunterTimersStatus"..(i-1), "TOP", 0, KHTvars["bardistance"] );
		end
	end

	KHunterTimersFrame:SetScale( KHTvars["scale"] );
	KHunterTimersFrame:SetAlpha( KHTvars["overallalpha"] );
	for i=1, KHT_NUM_BARS do
		getglobal("KHunterTimersStatus"..i):SetScale( KHTvars["scale"] );
		getglobal("KHunterTimersStatus"..i):SetAlpha( KHTvars["overallalpha"] );
	end

end

function KHT_SetHeight()
	local height; 
	if( not KHTvars["largetex"] ) or ( KHTvars["barheight"] >= 16 ) then
		height = KHTvars["numBars"] * (KHTvars["barheight"] + KHTvars["bardistance"]) - KHTvars["bardistance"] + 10;
	else
		height = KHTvars["numBars"] * (16 + KHTvars["bardistance"]) - KHTvars["bardistance"] + 10;
	end
	
	if( KHTvars["padding"] ) then
		height = height + 10;
	end
	
	KHunterTimersFrame:SetHeight(height);
	KHunterTimers_SetWidths();
end

function KHunterTimers_UpdateSpells()

	for key,val in pairs(KHTvars["skills"]) do
		local i = 1;
		while( GetSpellTexture(i, BOOKTYPE_SPELL) ) do
			local spellName = GetSpellName(i, BOOKTYPE_SPELL);
			if( spellName == key ) then
				KHTvars["textures"][key] = GetSpellTexture(i, BOOKTYPE_SPELL);
				break;
			end
			i = i + 1;
		end
	end

	-- Racials
	KHTvars["textures"][KHT_BERSERKING]		= "Interface\\Icons\\Racial_Troll_Berserk";
	KHTvars["textures"][KHT_BLOOD_FURY]		= "Interface\\Icons\\Racial_Orc_BerserkerStrength";

	-- Set/Item Procs
	KHTvars["textures"][KHT_EXPOSE_WEAKNESS]	= "Interface\\Icons\\Ability_Hunter_SniperShot";
	KHTvars["textures"][KHT_PRIMAL_BLESSING]	= "Interface\\Icons\\Ability_Hunter_Harass";
	KHTvars["textures"][KHT_SANTOS]			= "Interface\\Icons\\Spell_Arcane_PrismaticCloak";
	KHTvars["textures"][KHT_HEROIC]			= "Interface\\Icons\\Spell_Holy_Heroism";
	KHTvars["textures"][KHT_SKYFIRE]			= "Interface\\Icons\\Ability_Hunter_SerpentSwiftness";
	KHTvars["textures"][KHT_BEASTLORD]			= "Interface\\Icons\\Ability_Hunter_AimedShot";

	-- Talent Procs
	KHTvars["textures"][KHT_ENTRAPMENT]		= "Interface\\Icons\\Spell_Nature_StrangleVines";
	KHTvars["textures"][KHT_QUICK_SHOTS]		= "Interface\\Icons\\Ability_Warrior_InnerRage";
	KHTvars["textures"][KHT_FEROCIOUS]			= "Interface\\Icons\\Ability_Hunter_FerociousInspiration";
	KHTvars["textures"][KHT_RAPID_KILLING]		= "Interface\\Icons\\Ability_Hunter_RapidKilling";
	KHTvars["textures"][KHT_TACTICIAN]			= "Interface\\Icons\\Ability_Hunter_MasterTactitian";
	KHTvars["textures"][KHT_CONC_BARRAGE]		= "Interface\\Icons\\Spell_Frost_Stun";

	-- Trinkets
	KHTvars["textures"][KHT_DEVILSAUR]			= "Interface\\Icons\\Ability_Hunter_Pet_Raptor";
	KHTvars["textures"][KHT_ZHM]				= "Interface\\Icons\\INV_Jewelry_Necklace_13";
	KHTvars["textures"][KHT_EARTHSTRIKE]		= "Interface\\Icons\\Spell_Nature_AbolishMagic";
	KHTvars["textures"][KHT_SWARMGUARD]		= "Interface\\Icons\\INV_Misc_AhnQirajTrinket_04";
	KHTvars["textures"][KHT_JOM_GABBAR]		= "Interface\\Icons\\Ability_Poisons";
	KHTvars["textures"][KHT_KISS_SPIDER]		= "Interface\\Icons\\INV_Trinket_Naxxramas04";
	KHTvars["textures"][KHT_FEROCITY]			= "Interface\\Icons\\Spell_Holy_MindVision";
	KHTvars["textures"][KHT_BURNING_HATRED]		= "Interface\\Icons\\INV_Jewelry_Talisman_04";
	KHTvars["textures"][KHT_ANCIENT_POWER]		= "Interface\\Icons\\Spell_Nature_AbolishMagic";
	KHTvars["textures"][KHT_NIGHTSEYE]			= "Interface\\Icons\\INV_Jewelcrafting_BlackPearlPanther";
	KHTvars["textures"][KHT_UNRAVELLER]		= "Interface\\Icons\\Racial_Orc_BerserkerStrength";
	KHTvars["textures"][KHT_LUST]				= "Interface\\Icons\\Spell_Shadow_DeathPact";
	KHTvars["textures"][KHT_HASTE]			= "Interface\\Icons\\Ability_Whirlwind";
	KHTvars["textures"][KHT_HEROISM]			= "Interface\\Icons\\Spell_Holy_MindVision";
	KHTvars["textures"][KHT_TSUNAMI]			= "Interface\\Icons\\Spell_Nature_UnrelentingStorm";
	KHTvars["textures"][KHT_ASHTONGUE]			= "Interface\\Icons\\Ability_Hunter_MasterMarksman";
	KHTvars["textures"][KHT_WRATH]			= "Interface\\Icons\\INV_Misc_Head_Dragon_Blue";
	KHTvars["textures"][KHT_DELUSIONAL]		= "Interface\\Icons\\Ability_Warrior_EndlessRage";
	KHTvars["textures"][KHT_KLEPTOMANIA]		= "Interface\\Icons\\INV_Misc_Bag_11";
	KHTvars["textures"][KHT_MANIC]			= "Interface\\Icons\\Ability_Rogue_Sprint";
	KHTvars["textures"][KHT_MARTYR]			= "Interface\\Icons\\Spell_Holy_SymbolOfHope";
	KHTvars["textures"][KHT_NARCISSISM]		= "Interface\\Icons\\Spell_Holy_DivinePurpose";
	KHTvars["textures"][KHT_PARANOIA]			= "Interface\\Icons\\Spell_Shadow_AuraOfDarkness";
	KHTvars["textures"][KHT_TALON]			= "Interface\\Icons\\Ability_ImpalingBolt";
	KHTvars["textures"][KHT_SKYGUARD]			= "Interface\\Icons\\INV_Jewelry_Talisman_06";

	-- Other
	KHTvars["textures"][KHT_FRENZY]			= "Interface\\Icons\\Ability_Druid_ChallangingRoar";
	KHTvars["textures"][KHT_PET_FRENZY]		= "Interface\\Icons\\INV_Misc_MonsterClaw_03";
	
end

function KHunterTimers_ClearActiveSpells()

	khtAutoShot = false;
	khtImpConc = false;
	khtRapidFire = false;
	khtQuickShots = false;
	khtPetIntim = false;
	khtIntimidation = false;
	khtWingClip = false;
	khtImpWing = false;
	khtFreezing = false;
	khtScatter = false;
	khtWyvern = false;
	khtFearBeast = false;
	khtExposeWeakness = false;
	khtHuntersMark = false;
	khtPrimalBlessing = false;
	khtEntrapment = false;
	khtBerserking = false;
	khtJomGabbar = false;
	khtSpider = false;
	khtFerocious = false;
	khtTactician = false;
	khtConcBarrage = false;
	khtWrath = false;
	khtPetFrenzy = false;
	khtHaste = false;
	
end

local KHTSetColorFunc = {
	[1] = function() KHTSetColor(1) end,
	[2] = function() KHTSetColor(2) end,
	[3] = function() KHTSetColor(3) end,
	[4] = function() KHTSetColor(4) end,
	[5] = function() KHTSetColor(5) end,
	[6] = function() KHTSetColor(6) end,
	[7] = function() KHTSetColor(7) end
};

local KHTSetOpacityFunc = {
	[1] = function() KHTSetOpacity(1) end,
	[2] = function() KHTSetOpacity(2) end,
	[3] = function() KHTSetOpacity(3) end,
	[4] = function() KHTSetOpacity(4) end,
	[5] = function() KHTSetOpacity(5) end,
	[6] = function() KHTSetOpacity(6) end,
	[7] = function() KHTSetOpacity(7) end
};

local KHTCancelFunc = {
	[1] = function(x) KHTCancelColor(1, x) end,
	[2] = function(x) KHTCancelColor(2, x) end,
	[3] = function(x) KHTCancelColor(3, x) end,
	[4] = function(x) KHTCancelColor(4, x) end,
	[5] = function(x) KHTCancelColor(5, x) end,
	[6] = function(x) KHTCancelColor(6, x) end,
	[7] = function(x) KHTCancelColor(7, x) end
};

function KHT_ColorPicker(id)
	CloseMenus();
	local texture = getglobal("KHunterTimersOptionsBarsColor"..id.."Swatch");
	ColorPickerFrame.func = KHTSetColorFunc[id];
	ColorPickerFrame:SetColorRGB(texture.r, texture.g, texture.b);
	ColorPickerFrame.previousValues = {r = texture.r, g = texture.g, b = texture.b, opacity =texture.a};
	ColorPickerFrame.cancelFunc = KHTCancelFunc[id];
	if( id < 5 ) then
		ColorPickerFrame.hasOpacity = true;
		ColorPickerFrame.opacity = 1 - texture.a;
		ColorPickerFrame.opacityFunc = KHTSetOpacityFunc[id];
	else
		ColorPickerFrame.hasOpacity = false;
	end
	
	
	--OpacityFrame.opacityFunc = KHTSetOpacityFunc[id];
	
	ColorPickerFrame:Show();
end

function KHTSetOpacity(id)
	local a = 1 - OpacitySliderFrame:GetValue();
	local texture = getglobal("KHunterTimersOptionsBarsColor"..id.."Swatch");
	--DEFAULT_CHAT_FRAME:AddMessage(id);
	texture:SetAlpha(a);
	texture.a = a;
end

function KHTSetColor(id)
	local r, g, b = ColorPickerFrame:GetColorRGB();
	local texture = getglobal("KHunterTimersOptionsBarsColor"..id.."Swatch");
	--KHTSetOpacity(id);
	texture:SetVertexColor(r, g, b);
	texture.r = r;
	texture.g = g;
	texture.b = b;
end

function KHTCancelColor(id, prev)
	local texture = getglobal("KHunterTimersOptionsBarsColor"..id.."Swatch");
	local r = prev.r;
	local g = prev.g;
	local b = prev.b;
	local a = prev.opacity;
	texture:SetVertexColor(r, g, b);
	texture:SetAlpha( a );
	texture.r = r;
	texture.g = g;
	texture.b = b;
	texture.a = a;
end

function KHTColor(r, g, b, a)
	if( not a ) then
		a = 1;
	end
	return string.format("|c%02x%02x%02x%02x", (a*255), (r*255), (g*255), (b*255));
end

function KHunterTimers_Tooltip( barframe )
	--DEFAULT_CHAT_FRAME:AddMessage(barframe:GetName());
	if( barframe.target ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, barframe);
		GameTooltip:ClearLines();
		GameTooltip:AddLine( barframe.target );
		GameTooltip:Show();
	end
end

function KHunterTimers_RacialsTooltip( button )
	GameTooltip_SetDefaultAnchor(GameTooltip, button);
	GameTooltip:ClearLines();
	GameTooltip:AddLine( "Racials" );
	GameTooltip:AddLine( " " );
	GameTooltip:AddLine( "Berserking" );
	GameTooltip:AddLine( "Blood Fury" );
	GameTooltip:Show();
end

function KHunterTimers_SetItemTooltip( button )
	GameTooltip_SetDefaultAnchor(GameTooltip, button);
	GameTooltip:ClearLines();
	GameTooltip:AddLine( "Set/Item Procs" );
	GameTooltip:AddLine( " " );
	GameTooltip:AddLine( "Exploited Weakness" );
	GameTooltip:AddLine( "Expose Weakness" );
	GameTooltip:AddLine( "Heroic Resolution" );
	GameTooltip:AddLine( "Primal Blessing" );
	GameTooltip:AddLine( "Santos' Blessing" );
	GameTooltip:AddLine( "Skyfire Swiftness" );
	GameTooltip:Show();
end

function KHunterTimers_TalentTooltip( button )
	GameTooltip_SetDefaultAnchor(GameTooltip, button);
	GameTooltip:ClearLines();
	GameTooltip:AddLine( "Talent Procs" );
	GameTooltip:AddLine( " " );
	GameTooltip:AddLine( "Concussive Barrage" );
	GameTooltip:AddLine( "Expose Weakness" );
	GameTooltip:AddLine( "Ferocious Inspiration" );
	GameTooltip:AddLine( "Master Tactician" );
	GameTooltip:AddLine( "Quick Shots" );
	GameTooltip:AddLine( "Rapid Killing" );
	GameTooltip:Show();
end

function KHunterTimers_TrinketsTooltip( button )
	GameTooltip_SetDefaultAnchor(GameTooltip, button);
	GameTooltip:ClearLines();
	GameTooltip:AddLine( "Trinkets" );
	GameTooltip:AddLine( " " );
	GameTooltip:AddLine( "Abacus of the Violent Odds" );
	GameTooltip:AddLine( "Ancient Draenei War Talisman" );
	GameTooltip:AddLine( "Ashtongue Talisman of Swiftness" );
	GameTooltip:AddLine( "Badge of the Swarmguard" );
	GameTooltip:AddLine( "Bladefist's Breath" );
	GameTooltip:AddLine( "Bloodlust Brooch" );
	GameTooltip:AddLine( "Core of Ar'kelos" );
	GameTooltip:AddLine( "Darkmoon Card: Madness" );
	GameTooltip:AddLine( "Darkmoon Card: Wrath" );
	GameTooltip:AddLine( "Devilsaur Eye" );
	GameTooltip:AddLine( "Dragonspine Trophy" );
	GameTooltip:AddLine( "Earthstrike" );
	GameTooltip:AddLine( "Hourglass of the Unraveller" );
	GameTooltip:AddLine( "Jom Gabbar" );
	GameTooltip:AddLine( "Kiss of the Spider" );
	GameTooltip:AddLine( "Nightseye Panther" );
	GameTooltip:AddLine( "Ogre Mauler's Badge" );
	GameTooltip:AddLine( "Skyguard Silver Cross" );
	GameTooltip:AddLine( "Talon of Al'ar" );
	GameTooltip:AddLine( "Terrokar Tablet of Precision" );
	GameTooltip:AddLine( "Tsunami Talisman" );
	GameTooltip:AddLine( "Uniting Charm" );
	GameTooltip:AddLine( "Zandalarian Hero Medallion" );
	GameTooltip:Show();
end

function KHT_sfind( s, pattern )
	for p in string.gmatch( pattern, "([^|]+)" ) do
		if( string.find( s, p ) )then
			return string.find( s, p );
		end
	end
	return false;
end
